'George W. Bleck
'Lead Computer Systems Engineer
'KeySpan Corporation
'
'Here is an all code BFF replacement with test harness.
'
'[b]Features[/b]
'[list]
'[*]Can browse for Directories only or Directories and Files
'[*]Uses proper icons in the Treeview display
'[*]Dyamically builds the directory hierarchy [i]on-the-fly[/i] to save time and memory
'[*]Removes collapsed nodes from the Treeview to save memory
'[*]Allows masking based on file and directory attributes (read only, hidden, system)
'[*]Allows cut-and-paste of the path without actually saying "OK"
'[*]Fully customizable title and message
'[*]Fully customizable drive type selections
'[*]Fully customizable file match mask
'[*]Fully customizable [i]everything[/i] as you can change the code     :D
'[/list]

'----------------------------------------------------------------------------(')
#COMPILE EXE "Bff.exe"
#DIM ALL
'#IF NOT %DEF(%WINAPI)
'	#INCLUDE "WIN32API.INC"
'#ENDIF
'#IF NOT %DEF(%COMMCTRL_INC)
'	#INCLUDE "COMMCTRL.INC"
'#ENDIF
'-----------------------------------------------------------------
' Equates:  85
'-----------------------------------------------------------------
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%WM_USER                                        = &H400
%LF_FACESIZE                                    = 32
%FILE_ATTRIBUTE_DIRECTORY                       = &H00000010
%ReadOnly                                       = &B000001
%Hidden                                         = &B000010
%System                                         = &B000100
%SubDir                                         = &B010000
%Archive                                        = &B100000
%MAX_PATH                                       = 260  ' max. length of full pathname
%FF_DONTCARE                                    = 0    '  Don't care or don't know.
%FW_DONTCARE                                    = 0
%FW_NORMAL                                      = 400
%LOGPIXELSY                                     = 90   ' Logical pixels/inch in Y
%SHGFI_SYSICONINDEX                             = &H00004000  ' get system icon index
%SHGFI_SMALLICON                                = &H00000001  ' get small icon
%SHGFI_USEFILEATTRIBUTES                        = &H00000010  ' use passed dwFileAttribute
%VK_RETURN                                      = &H0D
%VK_ESCAPE                                      = &H1B
%WM_DESTROY                                     = &H2
%WM_NOTIFY                                      = &H4E
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_BORDER                                      = &H00800000
%WS_DLGFRAME                                    = &H00400000
%WS_VSCROLL                                     = &H00200000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_EX_WINDOWEDGE                               = &H00000100
%WS_EX_CLIENTEDGE                               = &H00000200
%WS_EX_LEFT                                     = &H00000000
%WS_EX_LTRREADING                               = &H00000000
%WS_EX_RIGHTSCROLLBAR                           = &H00000000
%WS_EX_CONTROLPARENT                            = &H00010000
%CS_DROPSHADOW                                  = &H00020000
%HWND_DESKTOP                                   = 0
%ES_LEFT                                        = &H0&
%ES_MULTILINE                                   = &H4&
%ES_AUTOVSCROLL                                 = &H40&
%ES_READONLY                                    = &H800&
%BN_CLICKED                                     = 0
%DS_3DLOOK                                      = &H0004&
%DS_NOFAILCREATE                                = &H0010&
%DS_SETFONT                                     = &H0040& '  User specified font for Dlg controls
%DS_MODALFRAME                                  = &H0080& '  Can be combined with WS_CAPTION
%DS_CENTER                                      = &H0800&
%SHFILEINFO_DEFINED                             = 1
%COMMCTRL_INC                                   = 1
%TV_FIRST                                       = &H1100      ' TreeView messages
%TVN_FIRST                                      = 0-400       ' treeview
%TVS_HASBUTTONS                                 = &H00000001
%TVS_HASLINES                                   = &H00000002
%TVS_LINESATROOT                                = &H00000004
%TVS_SHOWSELALWAYS                              = &H00000020
%TVIF_TEXT                                      = &H0001
%TVIF_IMAGE                                     = &H0002
%TVIF_HANDLE                                    = &H0010
%TVIF_SELECTEDIMAGE                             = &H0020
%TVIF_CHILDREN                                  = &H0040
%TVI_ROOT                                       = &HFFFF0000???
%TVI_LAST                                       = &HFFFF0002???
%TVM_INSERTITEM                                 = %TV_FIRST + 0
%TVM_DELETEITEM                                 = %TV_FIRST + 1
%TVM_EXPAND                                     = %TV_FIRST + 2
%TVE_COLLAPSE                                   = &H00000001
%TVE_EXPAND                                     = &H00000002
%TVE_COLLAPSERESET                              = &H00008000
%TVSIL_NORMAL                                   = 0
%TVM_SETIMAGELIST                               = %TV_FIRST + 9
%TVM_GETNEXTITEM                                = %TV_FIRST + 10
%TVGN_PARENT                                    = &H0003
%TVGN_CHILD                                     = &H0004
%TVGN_CARET                                     = &H0009
%TVM_GETITEM                                    = %TV_FIRST + 12
%TVM_SETITEM                                    = %TV_FIRST + 13
%TVN_SELCHANGED                                 = %TVN_FIRST - 2
%TVN_ITEMEXPANDING                              = %TVN_FIRST - 5
%WM_SETFONT                                     = &H30

'-----------------------------------------------------------------
' TYPE and UNION structures:  17
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE FILETIME
  dwLowDateTime AS DWORD
  dwHighDateTime AS DWORD
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    style AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS DWORD
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS DWORD
  dwReserved1 AS DWORD
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternateFileName AS ASCIIZ * 14
END TYPE

TYPE BITMAP
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS WORD
  bmBitsPixel AS WORD
  bmBits AS BYTE PTR
END TYPE

TYPE LOGFONT
  lfHeight AS LONG
  lfWidth AS LONG
  lfEscapement AS LONG
  lfOrientation AS LONG
  lfWeight AS LONG
  lfItalic AS BYTE
  lfUnderline AS BYTE
  lfStrikeOut AS BYTE
  lfCharSet AS BYTE
  lfOutPrecision AS BYTE
  lfClipPrecision AS BYTE
  lfQuality AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName AS ASCIIZ * %LF_FACESIZE
END TYPE

TYPE DRAWITEMSTRUCT
  CtlType AS DWORD
  CtlID AS DWORD
  itemID AS DWORD
  itemAction AS DWORD
  itemState AS DWORD
  hwndItem AS LONG
  hDC AS DWORD
  rcItem AS RECT
  itemData AS DWORD
END TYPE

TYPE SHFILEINFO
        hIcon AS DWORD                        'out: icon
        iIcon AS LONG                         'out: icon index
        dwAttributes AS DWORD                 'out: SFGAO_ flags
        szDisplayName AS ASCIIZ * %MAX_PATH   'out: display name (or path)
        szTypeName AS ASCIIZ * 80             'out: type name
END TYPE

TYPE NMHDR
  hwndFrom AS DWORD
  idfrom AS DWORD
  code AS LONG    ' used for messages, so needs to be LONG, not DWORD...
END TYPE

TYPE INIT_COMMON_CONTROLSEX
    dwSize AS DWORD   ' size of this structure
    dwICC  AS DWORD   ' flags indicating which classes to be initialized
END TYPE

TYPE TV_ITEM
    mask           AS DWORD
    hItem          AS DWORD
    STATE          AS DWORD
    stateMask      AS DWORD
    pszText        AS ASCIIZ PTR
    cchTextMax     AS LONG
    iImage         AS LONG
    iSelectedImage AS LONG
    cChildren      AS LONG
    lParam         AS LONG
END TYPE

TYPE TVITEMEX
    mask           AS DWORD
    hItem          AS DWORD
    STATE          AS DWORD
    stateMask      AS DWORD
    pszText        AS ASCIIZ PTR
    cchTextMax     AS LONG
    iImage         AS LONG
    iSelectedImage AS LONG
    cChildren      AS LONG
    lParam         AS LONG
    iIntegral      AS LONG
END TYPE

UNION TV_ITEM_UNION
    itemex AS TVITEMEX
    item   AS TV_ITEM
END UNION

TYPE TV_INSERTSTRUCT
    hParent      AS DWORD
    hInsertAfter AS DWORD
    item         AS TV_ITEM_UNION
END TYPE

TYPE NM_TREEVIEW
    hdr     AS NMHDR
    action  AS DWORD
    itemOld AS TV_ITEM
    itemNew AS TV_ITEM
    ptDrag  AS POINTAPI
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  14
'-----------------------------------------------------------------
DECLARE FUNCTION CreateFontIndirect LIB "GDI32.DLL" ALIAS "CreateFontIndirectA" (lpLogFont AS LOGFONT) AS DWORD
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION FindNextFile LIB "KERNEL32.DLL" ALIAS "FindNextFileA" (BYVAL hFindFile AS DWORD, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetDeviceCaps LIB "GDI32.DLL" ALIAS "GetDeviceCaps" (BYVAL hdc AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetDriveType LIB "KERNEL32.DLL" ALIAS "GetDriveTypeA" (nDrive AS ASCIIZ) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SHGetFileInfo LIB "SHELL32.DLL" ALIAS "SHGetFileInfoA" (pszPath AS ASCIIZ, BYVAL dwFileAttributes AS DWORD, psfi AS SHFILEINFO, BYVAL cbFileInfo AS DWORD, BYVAL uFlags AS DWORD) AS DWORD
DECLARE FUNCTION TerminateThread LIB "KERNEL32.DLL" ALIAS "TerminateThread" (BYVAL hThread AS DWORD, BYVAL dwExitCode AS DWORD) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD

'-----------------------------------------------------------------
' Declared Subs:  1
'-----------------------------------------------------------------
DECLARE SUB InitCommonControls LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ()

'-----------------------------------------------------------------
' Functions:  9  (begins with declarations)
'-----------------------------------------------------------------
DECLARE FUNCTION TreeView_InsertItem (BYVAL hWnd AS LONG, lpis AS TV_INSERTSTRUCT) _
           AS DWORD
DECLARE FUNCTION TreeView_DeleteItem (BYVAL hWnd AS DWORD, BYVAL hitem AS DWORD) _
           AS LONG
DECLARE FUNCTION TreeView_Expand (BYVAL hWnd AS DWORD, BYVAL hitem AS LONG, _
           BYVAL code AS DWORD) AS LONG
DECLARE FUNCTION TreeView_SetImageList (BYVAL hWnd AS DWORD, BYVAL himl AS DWORD, _
           BYVAL iImage AS LONG) AS DWORD
DECLARE FUNCTION TreeView_GetNextItem (BYVAL hWnd AS DWORD, BYVAL hitem AS DWORD, _
           BYVAL code AS DWORD) AS DWORD
DECLARE FUNCTION TreeView_GetChild (BYVAL hwnd AS DWORD, BYVAL hitem AS DWORD) AS DWORD
DECLARE FUNCTION TreeView_GetParent (BYVAL hwnd AS DWORD, BYVAL hitem AS DWORD) _
           AS DWORD
DECLARE FUNCTION TreeView_GetSelection (BYVAL hwnd AS DWORD) AS DWORD
DECLARE FUNCTION TreeView_GetItem (BYVAL hwnd AS DWORD, pitem AS TV_ITEM) AS LONG
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
FUNCTION TreeView_InsertItem (BYVAL hWnd AS LONG, lpis AS TV_INSERTSTRUCT) _
   AS DWORD
    FUNCTION = SendMessage(hWnd, %TVM_INSERTITEM, 0, VARPTR(lpis))
END FUNCTION

FUNCTION TreeView_DeleteItem (BYVAL hWnd AS DWORD, BYVAL hitem AS DWORD) _
   AS LONG
    FUNCTION = SendMessage(hWnd, %TVM_DELETEITEM, 0, hitem)
END FUNCTION

FUNCTION TreeView_Expand (BYVAL hWnd AS DWORD, BYVAL hitem AS LONG, _
   BYVAL code AS DWORD) AS LONG
    FUNCTION = SendMessage(hWnd, %TVM_EXPAND, code, hitem)
END FUNCTION

FUNCTION TreeView_SetImageList (BYVAL hWnd AS DWORD, BYVAL himl AS DWORD, _
   BYVAL iImage AS LONG) AS DWORD
    FUNCTION = SendMessage(hWnd, %TVM_SETIMAGELIST, iImage, himl)
END FUNCTION

FUNCTION TreeView_GetNextItem (BYVAL hWnd AS DWORD, BYVAL hitem AS DWORD, _
   BYVAL code AS DWORD) AS DWORD
    FUNCTION = SendMessage(hWnd, %TVM_GETNEXTITEM, code, hitem)
END FUNCTION

FUNCTION TreeView_GetChild (BYVAL hwnd AS DWORD, BYVAL hitem AS DWORD) AS DWORD
    FUNCTION = TreeView_GetNextItem(hwnd, hitem, %TVGN_CHILD)
END FUNCTION

FUNCTION TreeView_GetParent (BYVAL hwnd AS DWORD, BYVAL hitem AS DWORD) _
   AS DWORD
    FUNCTION = TreeView_GetNextItem(hwnd, hitem, %TVGN_PARENT)
END FUNCTION

FUNCTION TreeView_GetSelection (BYVAL hwnd AS DWORD) AS DWORD
    FUNCTION = TreeView_GetNextItem(hwnd, %NULL, %TVGN_CARET)
END FUNCTION

FUNCTION TreeView_GetItem (BYVAL hwnd AS DWORD, pitem AS TV_ITEM) AS LONG
    FUNCTION = SendMessage(hwnd, %TVM_GETITEM, 0, VARPTR(pitem))
END FUNCTION

#INCLUDE "WinLIFT.inc"

'This is the include file
'----------------------------------------------------------------------------(')
DECLARE CALLBACK FUNCTION libBFF_dlgMainCallback( )
DECLARE FUNCTION libBFF_dlgMain( BYVAL hParent AS DWORD, strTitle AS STRING, strMessage AS STRING ) AS STRING
DECLARE FUNCTION libBFF_GetIconIndex( strFilePath AS STRING ) AS DWORD
DECLARE FUNCTION libBFF_MakeIcon( ) AS DWORD
DECLARE FUNCTION libBFF_TVAddSubfilesToNode( BYVAL hITem AS DWORD ) AS LONG
DECLARE FUNCTION libBFF_TVGetFullPath( BYVAL hItem AS DWORD ) AS STRING
DECLARE FUNCTION libBFF_TVInsertItem( BYVAL hParent AS DWORD, strItem AS STRING, BYVAL lngChildrenFlag AS LONG, BYVAL lngIconIndex AS LONG ) AS LONG
DECLARE FUNCTION libBFF_IsInPath( BYVAL hItemToCollapse AS DWORD, BYVAL hCheckItem AS DWORD ) AS LONG
DECLARE SUB libBFF_TVFillRoot( )

'----------------------------------------------------------------------------(')

%SHFILEINFO_DEFINED = %TRUE

'----------------------------------------------------------------------------(')

'Dialog ID Constants

'----------------------------------------------------------------------------(')

%libBFF_ID_btnAccept = 1002
%libBFF_ID_btnClose = 1003
%libBFF_ID_dlgMain = 101
%libBFF_ID_edtSelectedPath = 1005
%libBFF_ID_staticMessage = 1004
%libBFF_ID_tvwDirectoryTree = 1001

'----------------------------------------------------------------------------(')

'libBFF_SettingsType.dwdShowType Constants

'----------------------------------------------------------------------------(')

%libBFF_ShowType_DirsOnly = 0
%libBFF_ShowType_DirsAndFiles = 1

'----------------------------------------------------------------------------(')

'libBFF_SettingsType.dwdDriveTypes Constants

'----------------------------------------------------------------------------(')

%libBFF_DriveType_RootDirectoryDoesNotExist = 2???
%libBFF_DriveType_Removable = 4???
%libBFF_DriveType_Fixed = 8???
%libBFF_DriveType_Remote = 16???
%libBFF_DriveType_RAMDisk = 64???
%libBFF_DriveType_CDROM = 32???
%libBFF_DriveType_AllExistingDrives = 124???

'----------------------------------------------------------------------------(')

$libBFF_IconPath = "$bffico$.ico"

'----------------------------------------------------------------------------(')

TYPE libBFF_SettingsType
	dwdShowType AS DWORD
	dwdDriveTypes AS DWORD
	dwdDirAttributeMask AS DWORD
	dwdFileAttributeMask AS DWORD
	strFileMatchMask AS STRING * 16
	strReturnedPath AS STRING * %MAX_PATH
	hTreeview AS DWORD		'used internally
END TYPE

'----------------------------------------------------------------------------(')

GLOBAL gstruct_libBFF_Settings AS libBFF_SettingsType

'----------------------------------------------------------------------------(')

FUNCTION libBFF_dlgMain( BYVAL hParent AS DWORD, strTitle AS STRING, strMessage AS STRING ) AS STRING
	LOCAL hDlg AS DWORD
	LOCAL lngResult AS LONG
	DIALOG NEW hParent, strTitle, 69, 76, 240, 291, %WS_POPUP OR %WS_BORDER OR %WS_DLGFRAME OR %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_CLIPSIBLINGS OR %WS_VISIBLE OR %DS_MODALFRAME OR %DS_CENTER OR %DS_3DLOOK OR %DS_NOFAILCREATE OR _
	  %DS_SETFONT, %WS_EX_WINDOWEDGE OR %WS_EX_CONTROLPARENT OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR, TO hDlg
	
  CONTROL ADD LABEL, hDlg, %libBFF_ID_staticMessage, strMessage, 9, 6, 222, 30

	CONTROL ADD "SysTreeView32", hDlg, %libBFF_ID_tvwDirectoryTree, "SysTreeView321", 9, 34, 222, 178, %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP OR %TVS_HASBUTTONS OR %TVS_HASLINES OR %TVS_LINESATROOT OR %TVS_SHOWSELALWAYS, _
	  %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING

	CONTROL ADD TEXTBOX, hDlg, %libBFF_ID_edtSelectedPath, "", 9, 216, 222, 36, %WS_CHILD OR %WS_VISIBLE OR %ES_LEFT OR %ES_READONLY OR %ES_MULTILINE OR %ES_AUTOVSCROLL OR %WS_VSCROLL,  _
                      %WS_EX_CLIENTEDGE OR %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
	CONTROL ADD BUTTON, hDlg, %libBFF_ID_btnAccept, "&Accept", 116, 262, 54, 21
	CONTROL ADD BUTTON, hDlg, %libBFF_ID_btnClose, "&Close", 179, 262, 54, 21

  IF skInitEngine("Seven.sks", "") THEN
     CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")
     'CONTROL SET FONT hDlg, %libBFF_ID_staticMessage, skFontBold()
     CALL SendMessage(GetDlgItem(hDLg, %libBFF_ID_staticMessage), %WM_SETFONT, skFontBold(), 0)
  END IF

	DIALOG SHOW MODAL hDlg, CALL libBFF_dlgMainCallback TO lngResult
	FUNCTION = TRIM$( gstruct_libBFF_Settings.strReturnedPath )
END FUNCTION

'----------------------------------------------------------------------------(')

CALLBACK FUNCTION libBFF_dlgMainCallback( )
	LOCAL hSelectedItem AS DWORD
	LOCAL hSystemImageList AS DWORD
	LOCAL lngResult AS LONG
	LOCAL structNMTreeview AS NM_TREEVIEW PTR
	LOCAL structSHFileInfo AS SHFILEINFO
	STATIC hThread AS DWORD
	STATIC hThreadItem AS DWORD
	SELECT CASE CBMSG
		CASE %WM_INITDIALOG
			INITCOMMONCONTROLS
			gstruct_libBFF_Settings.strReturnedPath = ""
			hSystemImageList = SHGETFILEINFO( "C:\", 0, structSHFileInfo, SIZEOF( structSHFileInfo ), %SHGFI_USEFILEATTRIBUTES OR %SHGFI_SMALLICON OR %SHGFI_SYSICONINDEX )
			CONTROL HANDLE CBHNDL, %libBFF_ID_tvwDirectoryTree TO gstruct_libBFF_Settings.hTreeview
			TreeView_SetImageList gstruct_libBFF_Settings.hTreeview, hSystemImageList, %TVSIL_NORMAL
			libBFF_TVFillRoot
			libBFF_MakeIcon
		CASE %WM_NOTIFY
			structNMTreeview = CBLPARAM
			SELECT CASE @structNMTreeview.hdr.Code
				CASE %TVN_ITEMEXPANDING
					SELECT CASE @structNMTreeview.action
						CASE %TVE_EXPAND
							THREAD STATUS hThread TO lngResult
							IF lngResult <> &H103 THEN
								'insert a place holder
								libBFF_TVInsertItem @structNMTreeview.itemNew.hItem, "Loading...", 0, libBFF_GetIconIndex( ENVIRON$( "TEMP" ) & $libBFF_IconPath )
								'Thread out the fill routine
								THREAD CREATE libBFF_TVAddSubfilesToNode( @structNMTreeview.itemNew.hItem ) TO hThread
								hThreadItem = @structNMTreeview.itemNew.hItem
							END IF
						CASE %TVE_COLLAPSE
							THREAD STATUS hThread TO lngResult
							IF lngResult = &H103 AND libBFF_IsInPath( @structNMTreeview.itemNew.hItem, hThreadItem ) THEN
								TERMINATETHREAD hThread, lngResult
								THREAD CLOSE hThread TO lngResult
							END IF
							TreeView_Expand gstruct_libBFF_Settings.hTreeview, @structNMTreeview.itemNew.hItem, %TVE_COLLAPSE OR %TVE_COLLAPSERESET
					END SELECT
				CASE %TVN_SELCHANGED
					hSelectedItem = TreeView_GetSelection( gstruct_libBFF_Settings.hTreeview )
					CONTROL SET TEXT CBHNDL, %libBFF_ID_edtSelectedPath, libBFF_TVGetFullPath( hSelectedItem )
			END SELECT
		CASE %WM_COMMAND
			SELECT CASE CBCTL
				CASE %libBFF_ID_btnAccept
					IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
						hSelectedItem = TreeView_GetSelection( gstruct_libBFF_Settings.hTreeview )
						IF hSelectedItem THEN
							gstruct_libBFF_Settings.strReturnedPath = libBFF_TVGetFullPath( hSelectedItem )

              CALL skDialogInfo("", $CR + "You selected" + $CR + $CR + libBFF_TVGetFullPath( hSelectedItem ), "")

							DIALOG END CBHNDL
						END IF
					END IF
				CASE %libBFF_ID_btnClose
					IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
						DIALOG END CBHNDL
					END IF
				CASE %WM_DESTROY
					THREAD STATUS hThread TO lngResult
					IF lngResult = &H103 THEN
						TERMINATETHREAD hThread, lngResult
						THREAD CLOSE hThread TO lngResult
					END IF
					KILL ENVIRON$( "TEMP" ) & $libBFF_IconPath
			END SELECT
	END SELECT
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION libBFF_IsInPath( BYVAL hItemToCollapse AS DWORD, BYVAL hCheckItem AS DWORD ) AS LONG
	FUNCTION = %TRUE
	DO WHILE hCheckItem
		IF hItemToCollapse = hCheckItem THEN EXIT FUNCTION
		hCheckItem = TreeView_GetParent( gstruct_libBFF_Settings.hTreeview, hCheckItem )
	LOOP
	FUNCTION = %FALSE
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION libBFF_TVInsertItem( BYVAL hParent AS DWORD, strItem AS STRING, BYVAL lngChildrenFlag AS LONG, BYVAL lngIconIndex AS LONG ) AS LONG
	LOCAL structTV_InsertStruct AS TV_INSERTSTRUCT
	structTV_InsertStruct.hParent = hParent
	structTV_InsertStruct.hInsertAfter = %TVI_LAST
	structTV_InsertStruct.Item.Item.mask = %TVIF_TEXT OR %TVIF_CHILDREN OR %TVIF_IMAGE OR %TVIF_SELECTEDIMAGE
	structTV_InsertStruct.Item.Item.pszText = STRPTR( strItem )
	structTV_InsertStruct.Item.Item.cchTextMax = LEN( strItem )
	structTV_InsertStruct.Item.Item.cChildren = lngChildrenFlag
	structTV_InsertStruct.Item.Item.iImage = lngIconIndex
	structTV_InsertStruct.Item.Item.iSelectedImage = lngIconIndex
	FUNCTION = TreeView_InsertItem( gstruct_libBFF_Settings.hTreeview, structTV_InsertStruct )
END FUNCTION

'----------------------------------------------------------------------------(')

SUB libBFF_TVFillRoot( )
	LOCAL aszDriveLetter AS ASCIIZ * 4
	LOCAL lngIndex AS LONG
	FOR lngIndex = 65 TO 90
		aszDriveLetter = CHR$( lngIndex ) & ":\"
		IF ( 2^ GETDRIVETYPE( aszDriveLetter ) AND gstruct_libBFF_Settings.dwdDriveTypes ) THEN
			libBFF_TVInsertItem %TVI_ROOT, LEFT$( aszDriveLetter, 2 ), 1, libBFF_GetIconIndex( BYCOPY aszDriveLetter )
		END IF
	NEXT lngIndex
END SUB

'----------------------------------------------------------------------------(')

FUNCTION libBFF_TVAddSubfilesToNode( BYVAL hITem AS DWORD ) AS LONG
	LOCAL lngIndex AS LONG
	LOCAL strArray( ) AS STRING
	LOCAL strDirFind AS STRING
	LOCAL strPath AS STRING
	LOCAL lngRefreshCounter AS LONG
	LOCAL structTVItem AS TV_ITEM
	LOCAL lngResult AS LONG
	LOCAL hFindFile AS DWORD
	LOCAL structWin32FindData AS WIN32_FIND_DATA
	strPath = libBFF_TVGetFullPath( hItem )
	'Get the dirs
	hFindFile = FINDFIRSTFILE( BYCOPY strPath & "\*.*", structWin32FindData )
	IF hFindFile THEN
		DO
			IF ( structWin32FindData.dwFileAttributes AND %FILE_ATTRIBUTE_DIRECTORY ) = %FILE_ATTRIBUTE_DIRECTORY THEN
				IF structWin32FindData.cFileName <> "." AND structWin32FindData.cFileName <> ".." THEN
					REDIM PRESERVE strArray( UBOUND( strArray ) + 1 )
					strArray( UBOUND( strArray )) = structWin32FindData.cFileName
				END IF
			END IF
		LOOP WHILE FINDNEXTFILE( hFindFile, structWin32FindData )
		ARRAY SORT strArray( ), COLLATE UCASE
		FINDCLOSE hFindFile
	END IF
	FOR lngIndex = 0 TO UBOUND( strArray )
		libBFF_TVInsertItem hItem, strArray( lngIndex ), 1, libBFF_GetIconIndex( strPath & "\" & strArray( lngIndex ))
		INCR lngRefreshCounter
	NEXT lngIndex
	IF gstruct_libBFF_Settings.dwdShowType AND %libBFF_ShowType_DirsAndFiles = %libBFF_ShowType_DirsAndFiles THEN
		ERASE strArray( )
		lngRefreshCounter = 0
		'get the files
		strDirFind = DIR$( strPath & "\" & TRIM$( gstruct_libBFF_Settings.strFileMatchMask ), gstruct_libBFF_Settings.dwdFileAttributeMask )
		DO UNTIL strDirFind = ""
			REDIM PRESERVE strArray( UBOUND( strArray ) + 1 )
			strArray( UBOUND( strArray )) = strDirFind
			strDirFind = DIR$
		LOOP
		ARRAY SORT strArray( ), COLLATE UCASE
		FOR lngIndex = 0 TO UBOUND( strArray )
			libBFF_TVInsertItem hItem, strArray( lngIndex ), 0, libBFF_GetIconIndex( strPath & "\" & strArray( lngIndex ))
			INCR lngRefreshCounter
		NEXT lngIndex
	END IF
	'Delete the loading place holder
	TreeView_DeleteItem gstruct_libBFF_Settings.hTreeview, TreeView_GetChild( gstruct_libBFF_Settings.hTreeview, hItem )
	IF TreeView_GetChild( gstruct_libBFF_Settings.hTreeview, hItem ) = 0 THEN
		structTVItem.mask = %TVIF_CHILDREN
		structTVItem.hItem = hItem
		structTVItem.cChildren = 0
		SENDMESSAGE gstruct_libBFF_Settings.hTreeview, %TVM_SETITEM, 0, BYVAL VARPTR( structTVITEM )
	END IF
	FUNCTION = lngResult
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION libBFF_GetIconIndex( strFilePath AS STRING ) AS DWORD
	LOCAL structSHFileInfo AS SHFILEINFO
	SHGETFILEINFO BYVAL STRPTR( strFilePath ), 0, structSHFileInfo, SIZEOF( structSHFileInfo ), %SHGFI_SMALLICON OR %SHGFI_SYSICONINDEX
	FUNCTION = structSHFileInfo.iIcon
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION libBFF_TVGetFullPath( BYVAL hItem AS DWORD ) AS STRING
	LOCAL aszBuffer AS ASCIIZ * %MAX_PATH + 1
	LOCAL hCurrent AS DWORD
	LOCAL strPath AS STRING
	LOCAL structTVItem AS TV_ITEM
	hCurrent = hItem
	structTVItem.mask = %TVIF_TEXT OR %TVIF_HANDLE
	structTVItem.cchTextMax = SIZEOF( aszBuffer )
	structTVItem.pszText = VARPTR( aszBuffer )
	DO UNTIL hCurrent = 0
		structTVItem.hItem = hCurrent
		TreeView_GetItem gstruct_libBFF_Settings.hTreeview, structTVItem
		strPath = aszBuffer & "\" & strPath
		hCurrent = TreeView_GetParent( gstruct_libBFF_Settings.hTreeview, hCurrent )
	LOOP
	FUNCTION = RTRIM$( strPath, "\" )
END FUNCTION

'----------------------------------------------------------------------------(')

FUNCTION libBFF_MakeIcon( ) AS DWORD
	LOCAL hFile AS DWORD
	hFile = FREEFILE
	OPEN ENVIRON$( "TEMP" ) & $libBFF_IconPath FOR BINARY AS #hFile
	PUT$ #hFile, PEEK$( CODEPTR( libBFF_MakeIcon_Data ), 318 )
	CLOSE #hFile
	EXIT FUNCTION
libBFF_MakeIcon_Data :
	!db 000,000,001,000,001,000,016,016,016,000,000,000,000,000,040,001,000,000,022,000,000,000
	!db 040,000,000,000,016,000,000,000,032,000,000,000,001,000,004,000,000,000,000,000,192,000
	!db 000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000
	!db 000,000,128,000,000,128,000,000,000,128,128,000,128,000,000,000,128,000,128,000,128,128
	!db 000,000,192,192,192,000,128,128,128,000,000,000,255,000,000,255,000,000,000,255,255,000
	!db 255,000,000,000,255,000,255,000,255,255,000,000,255,255,255,000,255,255,240,000,000,015
	!db 255,255,255,240,015,247,127,240,015,255,255,015,127,255,255,247,240,255,240,255,255,255
	!db 255,255,207,015,240,127,255,255,255,252,247,015,015,255,255,255,255,207,255,240,015,255
	!db 255,255,252,255,255,240,007,255,255,249,207,255,255,112,007,255,255,249,255,255,255,112
	!db 015,255,255,249,255,255,255,240,015,255,255,249,255,255,255,240,240,127,255,249,255,255
	!db 247,015,240,255,255,249,255,255,255,015,255,015,127,249,255,247,240,255,255,240,015,247
	!db 127,240,015,255,255,255,240,000,000,015,255,255,000,000,000,000,000,000,000,000,000,000
	!db 000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000
	!db 000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000
	!db 000,000,000,000,000,000,000,000,000,000
END FUNCTION

FUNCTION PBMAIN( )

	'Must fill in these settings before calling the BFF...see constant declarations for options
	gstruct_libBFF_Settings.dwdShowType = %libBFF_ShowType_DirsAndFiles
	gstruct_libBFF_Settings.dwdDriveTypes = %libBFF_DriveType_AllExistingDrives
	gstruct_libBFF_Settings.dwdDirAttributeMask = %READONLY OR %HIDDEN OR %SYSTEM OR %SUBDIR		'uses standard PB constants
	gstruct_libBFF_Settings.dwdFileAttributeMask = %READONLY OR %HIDDEN OR %SYSTEM OR %ARCHIVE		'uses standard PB constants
	gstruct_libBFF_Settings.strFileMatchMask = "*.*"
  

  libBFF_dlgMain(%HWND_DESKTOP, "BFF replacement", _
  "Select the file or directory you wish to use and click [Accept], click on [Close] to exit without selection." )

END FUNCTION
