#COMPILE EXE
'-----------------------------------------------------------------
' Equates:  31
'-----------------------------------------------------------------
%CBS_DROPDOWNLIST                               = &H3&
%WS_EX_RIGHT                                    = &H00001000
%WS_EX_LTRREADING                               = &H00000000
%WS_VSCROLL                                     = &H00200000
%WINAPI                                         = 1
%SW_HIDE                                        = 0
%SW_SHOW                                        = 5
%WM_DESTROY                                     = &H2
%WM_NOTIFY                                      = &H4E
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%WS_TABSTOP                                     = &H00010000
%WS_EX_CLIENTEDGE                               = &H00000200
%IDOK                                           = 1
%IDCANCEL                                       = 2
%EN_CHANGE                                      = &H300
%BN_CLICKED                                     = 0
%SS_SUNKEN                                      = &H00001000
%DS_CONTROL                                     = &H0400&
%SBS_VERT                                       = &H1&
%ICC_TAB_CLASSES                                = &H00000008 ' tab, tooltips
%TCM_FIRST                                      = &H1300      ' Tab control messages
%TCN_FIRST                                      = 0-550       ' tab control
%TCS_TOOLTIPS                                   = &H00004000
%TCIF_TEXT                                      = &H0001
%TCM_INSERTITEM                                 = %TCM_FIRST + 7
%TCM_GETITEMRECT                                = %TCM_FIRST + 10
%TCM_GETCURSEL                                  = %TCM_FIRST + 11
%TCN_SELCHANGE                                  = %TCN_FIRST - 1
%TCN_SELCHANGING                                = %TCN_FIRST - 2
%TBS_VERT           = &H0002
%TBS_HORZ           = &H0000
%TBS_AUTOTICKS      = &H0001
%TBS_NOTICKS        = &H0010

'-----------------------------------------------------------------
' TYPE and UNION structures:  4
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE NMHDR
  hwndFrom AS DWORD
  idfrom AS DWORD
  CODE AS LONG    ' used for messages, so needs to be LONG, not DWORD...
END TYPE

TYPE INIT_COMMON_CONTROLSEX
    dwSize AS DWORD   ' size of this structure
    dwICC  AS DWORD   ' flags indicating which classes to be initialized
END TYPE

TYPE TC_ITEM
    Mask          AS DWORD
    dwState       AS DWORD
    dwStateMask   AS DWORD
    pszText       AS ASCIIZ PTR
    cchTextMax    AS LONG
    iImage        AS LONG
    lParam        AS LONG
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  5
'-----------------------------------------------------------------
DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS LONG
DECLARE FUNCTION InitCommonControlsEx LIB "COMCTL32.DLL" ALIAS "InitCommonControlsEx" (icc AS INIT_COMMON_CONTROLSEX) AS LONG
DECLARE FUNCTION MessageBeep LIB "USER32.DLL" ALIAS "MessageBeep" (BYVAL dwType AS DWORD) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG

'-----------------------------------------------------------------
' Functions:  2  (begins with declarations)
'-----------------------------------------------------------------
DECLARE FUNCTION TabCtrl_InsertItem (BYVAL hwnd AS DWORD, BYVAL iItem AS DWORD, _
           pItem AS TC_ITEM) AS LONG
DECLARE FUNCTION TabCtrl_GetCurSel (BYVAL hwnd AS DWORD) AS LONG
'- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
FUNCTION TabCtrl_InsertItem (BYVAL hwnd AS DWORD, BYVAL iItem AS DWORD, _
   pItem AS TC_ITEM) AS LONG
    FUNCTION = SendMessage(hwnd, %TCM_INSERTITEM, iItem, VARPTR(pItem))
END FUNCTION

FUNCTION TabCtrl_GetCurSel (BYVAL hwnd AS DWORD) AS LONG
    FUNCTION = SendMessage(hwnd, %TCM_GETCURSEL, 0, 0)
END FUNCTION

#INCLUDE "WinLIFT.inc"

'--------------------------------------------------------------------
%ID_TAB      = 10
%ID_COMBOBOX = 11
'--------------------------------------------------------------------
GLOBAL hTab() AS DWORD
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgCallback() AS LONG
DECLARE CALLBACK FUNCTION Tab1Proc
DECLARE CALLBACK FUNCTION Tab2Proc
DECLARE CALLBACK FUNCTION Tab3Proc

'
' Main Dialog entrance
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD, K, nDW, nDH, nStyle AS LONG, txt AS STRING
  LOCAL rc AS RECT, tie AS TC_ITEM, icc AS INIT_COMMON_CONTROLSEX

  nDW = 311 : nDH = 180
  DIALOG NEW 0, "Tab template",,, nDW, nDH, %WS_CAPTION OR %WS_SYSMENU TO hDlg
  DIALOG SET ICON hDlg, "PROGRAM"

  CONTROL ADD BUTTON, hDlg, %IDOK,     "&Info",     nDW - 108, 162, 50, 16
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Cancel", nDW -  54, 162, 50, 16

'---------------------------------
' Create tab Control
'---------------------------------
  icc.dwICC = %ICC_TAB_CLASSES
  icc.dwSize = SIZEOF(icc)
  InitCommonControlsEx icc

  CONTROL ADD "SysTabControl32", hDlg, %ID_TAB, "", 4, 4, nDW - 8, nDH - 24, _
              %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %TCS_TOOLTIPS OR _
              %WS_CLIPSIBLINGS

'-----------------------
' Create tab pages
'-----------------------
  REDIM hTab(2)
  tie.mask = %TCIF_TEXT
  tie.iImage = -1

  txt = "&Tab page 1"
  tie.pszText = STRPTR(txt)
  TabCtrl_InsertItem GetDlgItem(hDlg, %ID_TAB), 0, tie

  txt = "&Tab page 2"
  tie.pszText = STRPTR(txt)
  TabCtrl_InsertItem GetDlgItem(hDlg, %ID_TAB), 1, tie

  txt = "&Tab page 3"
  tie.pszText = STRPTR(txt)
  TabCtrl_InsertItem GetDlgItem(hDlg, %ID_TAB), 2, tie

  CONTROL GET SIZE hDlg, %ID_TAB TO nDW, nDH
  CONTROL SEND hDlg, %ID_TAB, %TCM_GETITEMRECT, 0, VARPTR(rc)
  DIALOG PIXELS hDlg, rc.nRight, rc.nBottom TO UNITS rc.nRight, rc.nBottom

  nDW = nDW - 4
  nDH = nDH - rc.nBottom - 4

  DIALOG NEW hDlg, "" , 6, 6 + rc.nBottom, nDW, nDH, %WS_CHILD OR %DS_CONTROL TO hTab(0)
  DIALOG NEW hDlg, "" , 6, 6 + rc.nBottom, nDW, nDH, %WS_CHILD OR %DS_CONTROL TO hTab(1)
  DIALOG NEW hDlg, "" , 6, 6 + rc.nBottom, nDW, nDH, %WS_CHILD OR %DS_CONTROL TO hTab(2)

  '------------
  'Setup Tab #1
  '------------
  CONTROL ADD FRAME, hTab(0), 10, "Frame 1" ,             7,  4, 100, 38

    CONTROL ADD CHECKBOX, hTab(0), 110, "Beep at exit ", 13, 14,  60, 12 ', , %WS_EX_RIGHT OR %WS_EX_LTRREADING
'    CONTROL ADD CHECKBOX, hTab(0), 110, "Beep at exit ", 13, 14,  60, 12, _
'                          %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_TEXT OR _
'                          %BS_AUTOCHECKBOX  OR %BS_VCENTER OR %BS_LEFT OR %BS_LEFTTEXT

    CONTROL ADD CHECKBOX, hTab(0), 111, "Do whatever ",  13, 26,  60, 12
    CONTROL ADD LISTBOX,  hTab(0), 112, ,                 7, 54,  nDW - 14, 90
    FOR K = 1 TO 20
        LISTBOX ADD hTab(0), 112, "Item " + RIGHT$("00" + LTRIM$(STR$(K)), 2)
    NEXT

  '------------
  'Setup Tab #2
  '------------
  CONTROL ADD FRAME, hTab(1), 20, "Frame 2" ,       7,  4, 286, 30
    CONTROL ADD LABEL,    hTab(1),  -1, "Label",   12, 17,  40, 10
    CONTROL ADD TEXTBOX,  hTab(1), 220, "Text ",   52, 15, 232, 12, _
                          %WS_TABSTOP, %WS_EX_CLIENTEDGE
    CONTROL ADD LABEL,    hTab(1),  221, "Label2",  5,  40,  119, 79, %SS_SUNKEN
    ';;CONTROL ADD SCROLLBAR, hTab(1), 222, "", 125,  40,  11, 80, %WS_TABSTOP OR %SBS_VERT
    ';;CONTROL ADD SCROLLBAR, hTab(1), 223, "",   5, 120, 120, 10, %WS_TABSTOP
    CONTROL ADD "msctls_trackbar32", hTab(1), 222, "", 125,  40,  10, 80, %WS_CHILD OR %WS_VISIBLE OR %TBS_NOTICKS OR %TBS_VERT
    CONTROL ADD "msctls_trackbar32", hTab(1), 223, "",   5, 120, 120, 10, %WS_CHILD OR %WS_VISIBLE OR %TBS_NOTICKS OR %TBS_HORZ

  '------------
  'Setup Tab #3
  '------------
  CONTROL ADD FRAME, hTab(2), 10, "Frame 3" ,        7,  4, 100, 38
    CONTROL ADD OPTION, hTab(2), 310, "Option 1 ",  13, 14,  60, 12' , , %WS_EX_RIGHT
    CONTROL ADD OPTION, hTab(2), 311, "Option 2 ",  13, 26,  60, 12
    CONTROL SET CHECK hTab(2), 310, 1


    CONTROL ADD COMBOBOX, hTab(2), %ID_COMBOBOX, , 110, 9, 120, 200, _
                       %CBS_DROPDOWN OR %CBS_HASSTRINGS OR %CBS_SORT OR %WS_TABSTOP OR %WS_VSCROLL
    FOR K = 1 TO 20
        COMBOBOX ADD hTab(2), %ID_COMBOBOX, "Item " + RIGHT$("00" + LTRIM$(STR$(K)), 2)
    NEXT
    COMBOBOX SELECT hTab(2), %ID_COMBOBOX, 1

'---------------------------------
' Show Tab pages and Dialog
'---------------------------------
  DIALOG SHOW MODELESS hTab(2) CALL Tab3proc           ' For Tab page3 messages
  DIALOG SHOW MODELESS hTab(1) CALL Tab2proc           ' For Tab page2 messages
  DIALOG SHOW STATE hTab(2), %SW_HIDE                  ' Hide page 3
  DIALOG SHOW STATE hTab(1), %SW_HIDE                  ' Hide page 2
  DIALOG SHOW MODELESS hTab(0) CALL Tab1proc           ' Show page 1 initially

' ////////////////////////////////////////////////////////////////////////
' // Here we go for the magic WinLIFT section
  IF skInitEngine("Seven.sks", "") THEN
  'IF skInitEngine("Onyx.sks", "") THEN
     CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")
  END IF

  DIALOG SHOW MODAL hDlg CALL DlgCallback

END FUNCTION

'
' Main Dialog callback
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgCallback() AS LONG
  LOCAL lpNmh AS NMHDR PTR, lPage AS LONG

  SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         SetFocus GetDlgItem(CBHNDL, %ID_TAB) 'set initial focus to tab 1
         FUNCTION = 1

      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDOK      ' Ok button
               CALL skDialogInfo(skVersion(), "INFO" + $CR + $CR + $CR + "Displays a modal dialog box that contains a WinLIFT icon, a set of buttons, and a brief application-specific message.", "")

            CASE %IDCANCEL  ' Cancel button
               IF CBCTLMSG = %BN_CLICKED THEN DIALOG END CBHNDL

        END SELECT

     CASE %WM_DESTROY

     CASE %WM_NOTIFY
        lpNmh = CBLPARAM

        SELECT CASE @lpNmh.idFrom      ' trap tab page selection
           CASE %ID_TAB
              lPage = TabCtrl_GetCurSel(GetDlgItem(CBHNDL, %ID_TAB))

              SELECT CASE @lpNmh.Code
                 CASE %TCN_SELCHANGING ' cursel page is about to change
                    DIALOG SHOW STATE hTab(lPage), %SW_HIDE

                 CASE %TCN_SELCHANGE   ' cursel page shall be shown
                    DIALOG SHOW STATE hTab(lPage), %SW_SHOW

               END SELECT
        END SELECT

  END SELECT
END FUNCTION

'
' Callback procedure for tab page 1
'--------------------------------------------------------------------
CALLBACK FUNCTION Tab1Proc

  SELECT CASE CBMSG
     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE 110 : MessageBeep &HFFFFFFFF

        END SELECT
  END SELECT
END FUNCTION

'
' Callback procedure for tab page 2
'--------------------------------------------------------------------
CALLBACK FUNCTION Tab2Proc

  SELECT CASE CBMSG
     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE 220  ' text control on tab page 2
              IF CBCTLMSG = %EN_CHANGE THEN MessageBeep &HFFFFFFFF

        END SELECT
  END SELECT
END FUNCTION

'
' Callback procedure for tab page 3
'--------------------------------------------------------------------
CALLBACK FUNCTION Tab3Proc

  SELECT CASE CBMSG
     CASE %WM_COMMAND

  END SELECT
END FUNCTION
