'
' Template for DDT main dialog
'--------------------------------------------------------------------
#COMPILE EXE "Gauge.exe"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

%TRUE               = 1
%FALSE              = 0
%TBS_AUTOTICKS      = &H0001
%TBS_VERT           = &H0002
%TBS_HORZ           = &H0000
%TBS_TOP            = &H0004
%TBS_BOTTOM         = &H0000

%BM_GETCHECK            = &HF0
%BST_CHECKED            = &H01

%TBM_GETPOS             = %WM_USER
%TBM_GETRANGEMIN        = %WM_USER + 1
%TBM_GETRANGEMAX        = %WM_USER + 2
%TBM_GETTIC             = %WM_USER + 3
%TBM_SETTIC             = %WM_USER + 4
%TBM_SETPOS             = %WM_USER + 5
%TBM_SETRANGE           = %WM_USER + 6
%TBM_SETRANGEMIN        = %WM_USER + 7
%TBM_SETRANGEMAX        = %WM_USER + 8
%TBM_CLEARTICS          = %WM_USER + 9
%TBM_SETSEL             = %WM_USER + 10
%TBM_SETSELSTART        = %WM_USER + 11
%TBM_SETSELEND          = %WM_USER + 12
%TBM_GETPTICS           = %WM_USER + 14
%TBM_GETTICPOS          = %WM_USER + 15
%TBM_GETNUMTICS         = %WM_USER + 16
%TBM_GETSELSTART        = %WM_USER + 17
%TBM_GETSELEND          = %WM_USER + 18
%TBM_CLEARSEL           = %WM_USER + 19
%TBM_SETTICFREQ         = %WM_USER + 20
%TBM_SETPAGESIZE        = %WM_USER + 21
%TBM_GETPAGESIZE        = %WM_USER + 22
%TBM_SETLINESIZE        = %WM_USER + 23
%TBM_GETLINESIZE        = %WM_USER + 24
%TBM_GETTHUMBRECT       = %WM_USER + 25
%TBM_GETCHANNELRECT     = %WM_USER + 26
%TBM_SETTHUMBLENGTH     = %WM_USER + 27
%TBM_GETTHUMBLENGTH     = %WM_USER + 28
%TBM_SETTOOLTIPS        = %WM_USER + 29
%TBM_GETTOOLTIPS        = %WM_USER + 30
%TBM_SETTIPSIDE         = %WM_USER + 31

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

TYPE POINTAPI
    x AS LONG
    y AS LONG
END TYPE

TYPE NMHDR
    hwndFrom AS DWORD
    idfrom AS DWORD
    code AS LONG    ' used for messages, so needs to be LONG, not DWORD...
END TYPE


%WM_USER                                        = &H400
%WM_DRAWITEM                                    = &H2B
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WS_OVERLAPPED                                  = &H0
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_VSCROLL                                     = &H00200000
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_OVERLAPPEDWINDOW                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX

%BS_LEFT            = &H100&
%BS_RIGHT           = &H200&
%BS_CENTER          = &H300&
%BS_TOP             = &H400&
%BS_BOTTOM          = &H800&
%BS_VCENTER         = &HC00&


%IDC_GDIMAGE      = 101
%IDC_SLIDEZOOM    = 102
%IDC_NEWIMAGE     = 103
%IDC_CLOCK        = 122
%IDC_BIGKNOB      = 123
%IDC_LEFTKNOB     = 124
%IDC_RIGHTKNOB    = 125
%IDC_CHECKBOX     = 126
%IDC_DUMMY        = 9991

'// GDImage constant to identify each sprite image.
%ID_PHOTO         = 1
%ID_LOGO          = 2

'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc() AS LONG
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG

#INCLUDE "WINLIFT.INC"
#INCLUDE "GDIMAGE.INC"

GLOBAL hGDImage, hDlg AS DWORD, gnFocusID, gnTrueWidth, gnTrueHeight, gnUseWidth, gnUseHeight AS LONG, grWasZoom AS SINGLE

'
' Main entrance
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
    LOCAL hCtrl AS DWORD, sResource AS STRING, zFullpathToImage AS ASCIIZ * 260
    LOCAL p AS POINTAPI, rc AS RECT
    LOCAL imgW, imgH, xP, yP, xS, yS, hBitmap AS LONG

    DIALOG NEW PIXELS, 0, "Rotating knob",,, 780, 572, %WS_OVERLAPPEDWINDOW, 0 TO hDlg

    sResource = EXE.Path$ + "Resource\"

    IF RegisterGDImageClass() THEN
       hGDImage = CreateWindowEx(0, "ZIMAGECTRL", "", _ 
                                 %WS_CHILD Or %WS_VISIBLE, _ ' Or %WS_HSCROLL Or %WS_VSCROLL, _
                                 78, 40, 628, 432, _
                                 hDlg, %IDC_GDIMAGE, _
                                 zInstance(), _
                                 BYVAL 0&)


    END IF

'   // START OF SKINNING SECTION --------------------------------------------
    IF skInitEngine("Onyx.sks", "") THEN
       CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")

       CALL skSetAnchorCtrl(hGDImage, %ANCHOR_HEIGHT_RIGHT)

       hCtrl =    CreateWindowEx( 0, _
                                 "MSCTLS_TRACKBAR32", _
                                 "", _
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %TBS_VERT OR %TBS_BOTTOM OR %TBS_AUTOTICKS, _
                                 728, 40, 32, 432, _
                                 hDlg, %IDC_SLIDEZOOM, _
                                 zInstance(), _
                                 BYVAL 0&)
       CALL skSkinChildCtrl(hCtrl, 0): CALL skSetAnchorCtrl(hCtrl, %ANCHOR_RIGHT)

       hCtrl =    CreateWindowEx( 0, _
                                 "BUTTON", _
                                 "Show graphic in composited mode", _
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTOCHECKBOX, _
                                 500, 542, 200, 16, _
                                 hDlg, %IDC_CHECKBOX, _
                                 zInstance(), _
                                 BYVAL 0&)
       CALL skSkinChildCtrl(hCtrl, 0): CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)

'      // 4.73 WinLIFT clock
       hCtrl = skClockCtrl(hDlg, sResource + "Clock_09_92.png", 4, 476, 0, 0, %IDC_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
       CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM)
       CALL skCreateToolTip(hCtrl, "WinLIFT clock widget")

       hCtrl = skButtonImage(hDlg, sResource + "SelectImage.png", 780 - 58, 498, %IDC_NEWIMAGE, 5)
       CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM_RIGHT)
       CALL skCreateToolTip(hCtrl, "WinLIFT ButtonImage")

       hCtrl = skKnobGauge(hDlg, sResource + "BTN_Gauge01.png", 303, 527, 0, 0, %IDC_LEFTKNOB, 0, 0, 0, 0)
       CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
       CALL skCreateToolTip(hCtrl, "WinLIFT KnobGauge")
       hCtrl = skKnobGauge(hDlg, sResource + "BTN_Gauge02.png", 344, 476, 0, 0, %IDC_BIGKNOB, 0, 0, 0, 0)
       CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
       CALL skCreateToolTip(hCtrl, "WinLIFT KnobGauge")
       hCtrl = skKnobGauge(hDlg, sResource + "BTN_Gauge01.png", 436, 527, 0, 0, %IDC_RIGHTKNOB, 0, 0, 0, 0)
       CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
       CALL skCreateToolTip(hCtrl, "WinLIFT KnobGauge")

       IF hGDImage THEN

'         // Use the line below, only if you want it to make it a GDImage ZoomWindow.
          'CALL ZI_SetProperty(hGDImage, %ZI_ZoomWindow, 1)

'         // Add a skinned border around the GDImage control.
          CALL GetWindowRect(hGDImage, rc)
          p.X = rc.nLeft: p.Y = rc.nTop
          CALL ScreenToClient(hDlg, p)
          CALL skBorder(hGDImage, p.X - 1, p.Y - 1, rc.nRight - rc.nLeft + 2, rc.nBottom - rc.nTop + 2, 0, 1)
'         // Anchor the GDImage control.
          CALL skSetAnchorCtrl(hGDImage, %ANCHOR_HEIGHT_WIDTH)

'         // Compute the good range to use with the zoom slider
          CALL ZI_GetImageSizeFromControl(hGDImage, imgW, imgH)
          CALL ZI_Iconise(imgW, imgH, rc.nRight - rc.nLeft, rc.nBottom - rc.nTop, xP, yP, xS, yS)
          IF imgW THEN
             hCtrl = GetDlgItem(hDlg, %IDC_SLIDEZOOM)
             CALL SendMessage(hCtrl, %TBM_SETPAGESIZE, 0, 1)
             CALL SendMessage(hCtrl, %TBM_SETLINESIZE, 0, 1)
             CALL SendMessage(hCtrl, %TBM_SETTICFREQ, 0, 1)
             CALL SendMessage(hCtrl, %TBM_SETRANGE, 1, MAK(LONG, 1, imgW))
             CALL SendMessage(hCtrl, %TBM_SETPOS, 1, xS)
          END IF

'         // Start with the default picture.
          zFullpathToImage = sResource + "Daffodil.jpg"
          CALL UseThisPhoto(zFullpathToImage, 0)

'         // Add a transparent logo on the top right corner.
          zFullpathToImage = sResource + "GDImage.png"
'         // Load image and retrieve the width and height of its bitmap.
          hBitmap = ZI_CreateBitmapFromFile(zFullpathToImage, imgW, imgH)
'         // Use the new hBitmap to create a sprite image on the top right corner. 
          CALL ZD_DrawBitmapToCtrl(hGDImage, (rc.nRight - rc.nLeft) - (imgW + 10), 10, hBitmap, ZD_ColorARGB(255, 0), %ID_LOGO, %ZS_VISIBLE)
'         // Anchor the logo to the top right corner.
          CALL ZD_SetObjectAnchorMode(%ID_LOGO, %ANCHOR_RIGHT)
'         // Lock and disable the sprite image.
          CALL ZD_SetObjectLocked(%ID_LOGO, %TRUE)          

       END IF

    END IF

    'CONTROL ADD BUTTON, hDlg, %IDC_DUMMY, "bouton",  5, 5, 80, 24
    'hCtrl = GetDlgItem(hDlg, %IDC_DUMMY)
    'CALL skSkinChildCtrl(hCtrl, 0)
    'CALL skSkinWindowUpdate(hDlg, 0)

'   // END OF SKINNING SECTION ---------------------------------------------

    DIALOG SHOW MODAL hDlg CALL DlgProc

END FUNCTION

SUB GDImageSetZoomRange(BYVAL bmW AS LONG, BYVAL bmH AS LONG, xSize AS LONG, ySize AS LONG)
    LOCAL lpr AS RECT, xPos, yPos, hCtrl AS LONG
    CALL GetClientRect(hGDImage, lpr)
    CALL ZI_Iconise(bmW, bmH, lpr.nRight, lpr.nBottom, xPos, yPos, xSize, ySize)

    hCtrl = GetDlgItem(hDlg, %IDC_SLIDEZOOM)
    CALL SendMessage(hCtrl, %TBM_SETRANGE, 1, MAK(LONG, CLNG((xSize / bmW) * 128), 1500))
END SUB

'SUB UpdateQualityStatus(BYVAL bQuality AS LONG)
'    LOCAL nInterpolation AS LONG
'    IF bQuality THEN
'       nInterpolation = 2 ' %InterpolationModeHighQuality
'    ELSE
'       nInterpolation = 0 ' %InterpolationModeDefault
'    END IF
'    IF ZD_GetObjectQuality(%ID_PHOTO) <> nInterpolation THEN
'       CALL ZD_SetObjectQuality(%ID_PHOTO, nInterpolation, %TRUE)
'    END IF
'END SUB

SUB UseThisPhoto(BYVAL sUsePhoto AS STRING, BYVAL bReset AS LONG)
    LOCAL lpr AS RECT, rZoomValue AS SINGLE
    LOCAL nHbitmap, nW, nH, nX, nY, nSizeX, nSizeY, nPosAngle AS LONG, rAspect AS SINGLE
    
    '// Make sure to disable the crop rectangle if any
    IF ZI_GetToolCropStatus(hGDImage) THEN ZI_DisableCropRectangle(hGDImage)

    CALL ZI_GetImageSizeFromFile((sUsePhoto), gnTrueWidth, gnTrueHeight)
    nW = MAX&(gnTrueWidth, gnTrueHeight): IF nW > 1024 THEN nW = 1024
    nHbitmap = ZI_FitBitmapFromFile((sUsePhoto), nW, nW)

    CALL ZI_GetBitmapSize(nHbitmap, nW, nH)

    IF nHbitmap THEN
       gnUseWidth = nW: gnUseHeight = nH
'
       CALL zSplitN(sUsePhoto, "", sUsePhoto): sUsePhoto = UCASE$(LEFT$(sUsePhoto, 1)) + LCASE$(MID$(sUsePhoto, 2))
'
       '// Compute range based on the image size
       CALL GDImageSetZoomRange(gnUseWidth, gnUseHeight, nSizeX, nSizeY)
'
       CALL GetClientRect(hGDImage, lpr)
       CALL ZI_Iconise(gnTrueWidth, gnTrueHeight, lpr.nRight, lpr.nBottom, nX, nY, nW, nH)
       IF nW > nH THEN
          rAspect = nW / nH
       ELSE
          rAspect = 1
       END IF

       rZoomValue = (nSizeX / (gnUseWidth / rAspect))
       CALL SendMessage(GetDlgItem(hDlg, %IDC_SLIDEZOOM), %TBM_SETPOS, 1, CLNG(rZoomValue * 1000))

       CALL GetClientRect(hGDImage, lpr)
       nX = (lpr.nRight - gnUseWidth) / 2
       nY = (lpr.nBottom - gnUseHeight) / 2

       CALL ZD_DrawBitmapToCtrl(hGDImage, nX, nY, nHbitmap, ZD_ColorARGB(255, 0), %ID_PHOTO, %ZS_HIDDEN) '// %ZS_VISIBLE)
       CALL ZD_SetObjectScale(%ID_PHOTO, rZoomValue)

       nPosAngle = skGaugeGetPos(GetDlgItem(hDlg, %IDC_BIGKNOB))
       CALL ZD_SetObjectAngle(%ID_PHOTO, nPosAngle, %FALSE)
       CALL ZD_SetObjectAnchorMode(%ID_PHOTO, %ANCHOR_CENTER)

       'CALL UpdateQualityStatus(%TRUE)

       CALL SetFocus(hGDImage)
       CALL ZI_SetObjectFocusID(%ID_PHOTO)
       gnFocusID = %ID_PHOTO

       CALL ZD_SetObjectVisibility(%ID_PHOTO, %ZS_VISIBLE)
       CALL ZI_UpdateWindow(hGDImage, 0)
    END IF
END SUB

'
' Main callback
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgProc() AS LONG
    LOCAL hCtrl, hDW AS DWORD, ZoomValue, OldZoomValue AS SINGLE, nPos, imgW, imgH, xP, yP, xS, yS AS LONG
    LOCAL rc AS RECT, sDataString AS STRING
    LOCAL ptNMHDR AS NMHDR PTR

    SELECT CASE CBMSG

    CASE %WM_NOTIFY
         ptNMHDR = CBLPARAM
'        // Assign the new rotation angle to the sprite image.
         nPos = @ptNMHDR.code
         SELECT CASE LONG @ptNMHDR.idfrom
         CASE %IDC_BIGKNOB
            CALL ZD_SetObjectAngle(gnFocusID, nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hDlg, %IDC_LEFTKNOB), nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hDlg, %IDC_RIGHTKNOB), nPos, %TRUE)
         CASE %IDC_LEFTKNOB
            CALL ZD_SetObjectAngle(gnFocusID, nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hDlg, %IDC_BIGKNOB), nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hDlg, %IDC_RIGHTKNOB), nPos, %TRUE)
         CASE %IDC_RIGHTKNOB
            CALL ZD_SetObjectAngle(gnFocusID, nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hDlg, %IDC_BIGKNOB), nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hDlg, %IDC_LEFTKNOB), nPos, %TRUE)
         END SELECT

    CASE %WM_COMMAND

         SELECT CASE CBCTL
         CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN 'end prog
                 DIALOG END CBHNDL
              END IF

         CASE %IDC_NEWIMAGE
              hDW = ZI_CreateDW(CBHNDL)
              sDataString = ZI_LoadDialog(CBHNDL)
              CALL ZI_DestroyDW(hDW)

              IF LEN(sDataString) THEN
                 CALL UseThisPhoto(sDataString, 0)
              END IF

         CASE %IDC_CHECKBOX
              IF SendMessage(GetDlgItem(hDlg, %IDC_CHECKBOX), %BM_GETCHECK, 0, 0) = %BST_CHECKED THEN
                 CALL ZI_UseWinLIFTbackground(hGDImage, %TRUE, %TRUE)
              ELSE
                 CALL ZI_UseWinLIFTbackground(hGDImage, %FALSE, %TRUE)
              END IF
              CALL SetFocus(hGDImage)

         END SELECT

    CASE %WM_VSCROLL
         IF GetDlgCtrlId(CBLPARAM) = %IDC_SLIDEZOOM THEN
            CALL UseThisZoom(SendMessage(CBLPARAM, %TBM_GetPos, 0, 0)) '// Do not use nPosition, because it could be NULL.
         END IF

    END SELECT

END FUNCTION

SUB UseThisZoom(BYVAL nPos AS LONG)
    IF gnFocusID THEN 
       LOCAL nCtrl AS LONG, rZoomValue AS SINGLE
   
       rZoomValue = nPos / 1000
       IF rZoomValue <> grWasZoom THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)
    
          CALL ZD_SetObjectScale(gnFocusID, rZoomValue)
          CALL ZI_UpdateWindow(nCtrl, %FALSE)

       END IF
       grWasZoom = rZoomValue
    END IF
END SUB
