'******************************************************************************
'
'                            rvSomething  V 1.01a
'
'                           rvSomething  for PBWin 7
'
'                             Tested on Win ME.
'
'                           by RValois, June 2003.
'                           email: pb@rvalois.com.br
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
'
'******************************************************************************
'
'21/06/03 - 1.01 -  Added HasNoSolution function to check if randomly generated
'                   board has feasible solution.
'
#Compile Exe
#Dim All
'
#Include "WINLIFT.INC"

%WINAPI         = 1
%TRUE           = 1
%FALSE          = 0
%SW_HIDE        = 0
%SW_SHOW        = 5
%WM_COMMAND     = &H111
%WS_CAPTION     = &H00C00000
%WS_DLGFRAME    = &H00400000
%WS_SYSMENU     = &H00080000
%WS_TABSTOP     = &H00010000
%BS_CENTER      = &H300&
%BS_VCENTER     = &HC00&
%BN_CLICKED     = 0
%DS_CENTER      = &H0800&
%BS_DEFAULT     = &H1&
'
%START          = 100
%BTNSZ          = 32
%NUMBTN         = 4
%BTNSTARTID     = 1000
'
%WM_INITDIALOG       = &H110
'
$GameName = "rvGame"
'
Global PlayNum As Long
'
'******************************************************************************
Function CheckEndGame(ByVal hDlg As Dword) As Long
'******************************************************************************
  Local i As Long
  Local BtnLbl As String
'
  For i = 0 To %NUMBTN * %NUMBTN -2
    Control Get Text hDlg, %BTNSTARTID+i To BtnLbl
    If BtnLbl<>Str$(i+1) Then
      Function = %False
      Exit Function
    End If
  Next i
'
  Function = %True
'
End Function
'
'******************************************************************************
Function HasNoSolution(ByRef Board() As Long) As Long
'******************************************************************************
  Local i As Long
  Local Count As Dword
  Local Change As Long
'
  Change = %True
  While Change
    Change = %False
    For i = 0 To %NUMBTN*%NUMBTN - 2
      If Board(i)<>i+1 Then
        Swap Board(i),Board(Board(i)-1)
        Change = %True
        Incr Count
      End If
    Next i
  Wend
'
  Function = Count And 1???
'
End Function
'
'******************************************************************************
Sub RandBoard(ByVal hDlg As Dword)
'******************************************************************************
  Local i As Long
  Local NumBtns As Long
  Local Btn  As Long
  Dim BtnId(%NUMBTN*%NUMBTN-1) As Long
  Dim Board(%NUMBTN*%NUMBTN-1) As Long
  Dim BoardTmp(%NUMBTN*%NUMBTN-1) As Long
'
  Do
    NumBtns = %NUMBTN*%NUMBTN-1
'
    For i = 1 To %NUMBTN*%NUMBTN-1
      BtnId(i) = i
    Next i
'
    For i = 0 To %NUMBTN*%NUMBTN-2
      Btn = Rnd(1,NumBtns)
      Board(i)=BtnId(Btn)
      Array Delete BtnId(Btn)
      Decr NumBtns
    Next i
'
    Mat BoardTmp() = Board()
'
  Loop While HasNoSolution(BoardTmp())
'
  For i = 0 To %NUMBTN*%NUMBTN-2
    Control Set Text hDlg,%BTNSTARTID+i,Str$(Board(i))
    Control Show State hDlg,%BTNSTARTID+i,%SW_SHOW
  Next i
'
  Control Set Text hDlg,%BTNSTARTID+%NUMBTN*%NUMBTN-1,"0"
  Control Show State hDlg,%BTNSTARTID+%NUMBTN*%NUMBTN-1,%SW_HIDE
'
  PlayNum = 0
'
  Dialog Set Text hDlg, $GameName
'
End Sub
'
'******************************************************************************
Sub MovLbl(ByVal hDlg As Dword, ByVal IDBtnNew As Long, ByVal IDBtnOld As Long)
'******************************************************************************
  Local BtnLbl As String
'
  Control Show State hDlg,IDBtnOld ,%SW_HIDE
  Control Get Text hDlg, IDBtnOld To BtnLbl
  Control Set Text hDlg,IDBtnNew,BtnLbl
  Control Set Text hDlg,IDBtnOld ,"0"
  Control Show State hDlg,IDBtnNew,%SW_SHOW
'
  Incr PlayNum
  Dialog Set Text hDlg, $GameName + Str$(PlayNum)
'
  If CheckEndGame(hDlg) Then
    MsgBox "End"
    RandBoard hDlg
  End If
'
End Sub
'
'******************************************************************************
CallBack Function BtnStart()
'******************************************************************************
'
  If CbMsg = %WM_COMMAND And CbCtlMsg = %BN_CLICKED Then RandBoard CbHndl
'
End Function
'
'******************************************************************************
CallBack Function BtnProc()
'******************************************************************************
  Local BtnLbl As String
'
  If CbMsg = %WM_COMMAND And CbCtlMsg = %BN_CLICKED Then
'W
    If CbCtl-1 >=  %BTNSTARTID Then
      Control Get Text CbHndl, CbCtl-1 To BtnLbl
      If BtnLbl = "0" Then
        MovLbl CbHndl,CbCtl - 1,CbCtl
        Exit Function
      End If
    End If
'E
    If  CbCtl+1 < %BTNSTARTID + %NUMBTN*%NUMBTN Then
      Control Get Text CbHndl, CbCtl+1 To BtnLbl
      If BtnLbl = "0" Then
        MovLbl CbHndl,CbCtl+1,CbCtl
        Exit Function
      End If
    End If
'S
    If  CbCtl-%NUMBTN >= %BTNSTARTID Then
      Control Get Text CbHndl, CbCtl-%NUMBTN To BtnLbl
      If BtnLbl = "0" Then
        MovLbl CbHndl,CbCtl-%NUMBTN,CbCtl
        Exit Function
      End If
    End If
'N
    If CbCtl+%NUMBTN < %BTNSTARTID + %NUMBTN*%NUMBTN Then
      Control Get Text CbHndl, CbCtl+%NUMBTN To BtnLbl
      If BtnLbl = "0" Then
        MovLbl CbHndl,CbCtl+%NUMBTN,CbCtl
        Exit Function
      End If
    End If
'
  End If
'
End Function
'
CallBack Function DlgProc()

  Select Case CbMsg
    Case %WM_INITDIALOG
         IF skInitEngine("Chrome.sks", "") THEN
            CALL skSkinWindow(CbHndl, "Dock|Undock|Minimize|Maximize|Restore|Close")
         END IF
  End Select

End Function

'******************************************************************************
Function PBMain As Long
'******************************************************************************
  Local hDlg As Dword
  Local x As Long, y As Long
'
  Randomize
'
  Dialog New  0, $GameName,,, %NUMBTN *%BTNSZ , (%NUMBTN) *%BTNSZ  , _
              %WS_CAPTION Or %WS_SYSMENU Or %WS_DLGFRAME Or %DS_CENTER To hDlg
'
  For y = 0 To %NUMBTN -1
    For x = 0 To %NUMBTN -1
      Control Add Button, hDlg, %BTNSTARTID+y*%NUMBTN+x,"0",x*%BTNSZ,y*%BTNSZ,%BTNSZ,%BTNSZ, _
                          %BS_CENTER Or %BS_VCENTER Or %WS_TABSTOP Call BtnProc
    Next x
  Next y
'
  randBoard hDlg
'
  Dialog Show Modal hDlg, Call DlgProc
'
End Function
'
'******************************************************************************
'END
'******************************************************************************
