'==============================================================================
'=
'= E-MAIL : king.r.l@comcast.net or rayking@csdsoft.com
'= WEB URL: http://www.csdsoft.com (Under Construction)
'=
'==============================================================================
'= COPYRIGHT  2003, By Custom Software Designers. All Rights Reserved.
'= AUTHOR  : Raymond L. King.
'= COMPANY : Custom Software Designers.
'=
'== LICENCE/TERMS AND CONDITIONS ==============================================
'=
'= This code is free to all PowerBasic Users to use without acknowledging
'= the author, Raymond L. King (Custom Software Designers). Use this code as
'= you see fit.
'=
'= By using or compiling this code or derivative thereof, you are consenting to
'= hold the author, Raymond L. King (Custom Software Designers), harmless for
'= all effects or side-effects of its use. In other words, this code works for
'= me, but you are using it at your own risk.
'=
'= All support of this code will be provided (or not provided) at the discretion
'= of the author and with no guarantee as to the accuracy or timeliness of any
'= response. But I'll do my best to get back to you as soon as possible!
'=
'= I Raymond L. King (Custom Software Designers).
'= Place this Source Code into the Public Domain For All PowerBasic Users
'= to use as they want!
'=
'= A Special Thank you to Borje Hagsten for his DrawMenu Code Example.
'= A Special Thank you to Patrice for his WinLift Simplified API...
'==============================================================================

'==============================================================================
'= ApParams.inc - Is where you setup to load and save the applications
'= parameters, Also SEE - AppInitize and AppTerminate in this Include Module!
'= UDT Type - AppParametersTYPE is the UDT for all the application parameters.
'= udtAp - GLOBAL udtAp AS AppParametersTYPE for accessing the UDT...
'==============================================================================

'==============================================================================
'= Initial Declares - Eliminate Unnecessary Macros In COMMCTRL.INC.
'= Remark Out The Ones that you want to use.
'==============================================================================
'= You Can Disable Support (And Code) For The Various Common Controls By
'= Defining The Following Constants In Your Code *Before* The #INCLUDE
'= Statement.
'==============================================================================
%NOANIMATE         = 1  '= Animate Control         CLASSNAME: "SysAnimate32"
%NOBUTTON          = 1  '= Button                  CLASSNAME: "Button"
%NOCOMBO           = 1  '= Combo Box               CLASSNAME: "ComboBox"
%NOCOMBOEX         = 1  '= ComboBoxEx              CLASSNAME: "ComboBoxEx32"
%NODATETIMEPICK    = 1  '= Date/Time Picker        CLASSNAME: "SysDateTimePick32"
%NODRAGLIST        = 1  '= Drag List Control       CLASSNAME: "commctrl_DragListMsg"
%NOEDIT            = 1  '= Edit Control
%NOFLATSBAPIS      = 1  '= Flat Scroll Bar
%NOHEADER          = 1  '= Header Control          CLASSNAME: "SysHeader32"
%NOHOTKEY          = 1  '= HotKey Control          CLASSNAME: "msctls_hotkey32"
'%NOIMAGELIST       = 1  '= Image APIs
%NOIPADDRESS       = 1  '= IP Address Edit Control CLASSNAME: "SysIPAddress32"
%NOLIST            = 1  '= List Box Control
%NOLISTVIEW        = 1  '= ListView Control        CLASSNAME: "SysListView32"
%NOMENUHELP        = 1  '= Menu Help
%NOMONTHCAL        = 1  '= MonthCal                CLASSNAME: "SysMonthCal32"
%NOMUI             = 1  '= MUI
%NONATIVEFONTCTL   = 1  '= Native Font Control      CLASSNAME: "NativeFontCtl"
%NOPAGESCROLLER    = 1  '= Pager                    CLASSNAME: "SysPager"
%NOPROGRESS        = 1  '= Progress Control         CLASSNAME: "msctls_progress32"
'%NOREBAR           = 1  '= Rebar Control           CLASSNAME: "ReBarWindow32"
'%NOSTATUSBAR       = 1  '= Status Bar              CLASSNAME: "msctls_statusbar32"
%NOSYSLINK         = 1  '= SysLink                  CLASSNAME: "SysLink"
%NOTABCONTROL      = 1  '= Tab Control              CLASSNAME: "SysTabControl32"
'%NOTOOLBAR         = 1  '= Tool Bar                CLASSNAME: "ToolbarWindow32"
'%NOTOOLTIPS        = 1  '= Tool Tips               CLASSNAME: "tooltips_class32"
%NOTRACKBAR        = 1  '= Track Bar                CLASSNAME: "msctls_trackbar32"
%NOTRACKMOUSEEVENT = 1  '= Track Mouse Event
%NOTREEVIEW        = 1  '= TreeView                 CLASSNAME: "SysTreeView32"
%NOUPDOWN          = 1  '= Up Down Arrow Control    CLASSNAME: "msctls_updown32"
'= END OF COMMCTRL CONSTANTS. =================================================

'==============================================================================
'= COMPILER DIRECTIVES.
'==============================================================================
#COMPILE EXE

'==============================================================================
'= FIRST INCLUDE AND RESOURCE FILES.
'= These must be Included FIRST!
'==============================================================================
#RESOURCE "APPTEMP.PBR"
#INCLUDE "WINLIFT.INC"

'-----------------------------------------------------------------
' Equates:  122
'-----------------------------------------------------------------
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%WM_USER                                        = &H400
%LF_FACESIZE                                    = 32
%INVALID_HANDLE_VALUE                           = &HFFFFFFFF???
%LOCALE_USER_DEFAULT                            = &H0400&
%LR_LOADTRANSPARENT                             = &H0020
%LR_DEFAULTSIZE                                 = &H0040
%LR_LOADMAP3DCOLORS                             = &H1000
%MAX_PATH                                       = 260  ' max. length of full pathname
%SRCCOPY                                        = &H00CC0020 ' (DWORD) dest = source
%DEFAULT_CHARSET                                = 1
%FF_DONTCARE                                    = 0    ' Don't care or don't know.
%FW_DONTCARE                                    = 0
%FW_NORMAL                                      = 400
%FW_BOLD                                        = 700
%LOGPIXELSY                                     = 90   ' Logical pixels/inch in Y
%SW_SHOWNORMAL                                  = 1
%GWL_ID                                         = -12
%WM_DESTROY                                     = &H2
%WM_SIZE                                        = &H5
%WM_GETTEXTLENGTH                               = &HE
%WM_DRAWITEM                                    = &H2B
%WM_MEASUREITEM                                 = &H2C
%WM_SETFONT                                     = &H30
%WM_NOTIFY                                      = &H4E
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WM_TIMER                                       = &H113
%WM_HSCROLL                                     = &H114
%WM_INITMENUPOPUP                               = &H117
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_BORDER                                      = &H00800000
%WS_VSCROLL                                     = &H00200000
%WS_SYSMENU                                     = &H00080000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_EX_STATICEDGE                               = &H00020000
%CF_TEXT                                        =  1
%HWND_DESKTOP                                   = 0
%MB_OKCANCEL                                    = &H00000001&
%MB_ICONHAND                                    = &H00000010&
%MB_ICONERROR                                   = %MB_ICONHAND
%COLOR_BTNFACE                                  = 15
%COLOR_BTNTEXT                                  = 18
%MF_BYCOMMAND                                   = &H0&
%MF_ENABLED                                     = &H0&
%MF_GRAYED                                      = &H1&
%MF_DISABLED                                    = &H2&
%SC_CLOSE                                       = &HF060&
%EM_GETSEL                                      = &HB0
%EM_CANUNDO                                     = &HC6
%DS_CENTER                                      = &H0800&
%CBS_DROPDOWNLIST                               = &H3&
%IMAGE_BITMAP                                   = 0
%ICC_WIN95_CLASSES                              = &H000000FF
%ICC_COOL_CLASSES                               = &H00000400 ' rebar (coolbar) control
%TTN_FIRST                                      = 0-520       ' tooltips
%ILC_MASK                                       = &H00000001
%ILC_COLORDDB                                   = &H000000FE
%TBSTATE_ENABLED                                = &H0004
%TBSTYLE_BUTTON                                 = &H0000
%TBSTYLE_SEP                                    = &H0001
%TBSTYLE_AUTOSIZE                               = &H0010 ' automatically calculate the cx of the button
%TBSTYLE_TOOLTIPS                               = &H00000100
%TBSTYLE_FLAT                                   = &H00000800
%TBSTYLE_TRANSPARENT                            = &H00008000
%TB_ADDBITMAP                                   = %WM_USER + 19
%TB_ADDBUTTONS                                  = %WM_USER + 20
%TB_BUTTONSTRUCTSIZE                            = %WM_USER + 30
%TB_SETIMAGELIST                                = %WM_USER + 48
%TB_SETHOTIMAGELIST                             = %WM_USER + 52
%TB_SETDISABLEDIMAGELIST                        = %WM_USER + 54
%TB_GETBUTTONSIZE                               = %WM_USER + 58
%RBS_VARHEIGHT                                  = &H00000200
%RBS_BANDBORDERS                                = &H00000400
%RBBS_BREAK                                     = &H00000001  ' break to new line
%RBBS_FIXEDSIZE                                 = &H00000002  ' band can't be sized
%RBBS_CHILDEDGE                                 = &H00000004  ' edge around top & bottom of child window
%RBBS_NOVERT                                    = &H00000010  ' don't show when vertical
%RBBS_FIXEDBMP                                  = &H00000020  ' bitmap doesn't move during band resize
%RBBS_GRIPPERALWAYS                             = &H00000080  ' always show the gripper
%RBBIM_STYLE                                    = &H00000001
%RBBIM_COLORS                                   = &H00000002
%RBBIM_TEXT                                     = &H00000004
%RBBIM_CHILD                                    = &H00000010
%RBBIM_CHILDSIZE                                = &H00000020
%RBBIM_SIZE                                     = &H00000040
%RBBIM_BACKGROUND                               = &H00000080
%RBBIM_ID                                       = &H00000100
%RB_INSERTBAND                                  = (%WM_USER + 1)
%RB_SETBARINFO                                  = (%WM_USER + 4)
%RB_GETBANDCOUNT                                = (%WM_USER + 12)
%RB_GETROWCOUNT                                 = (%WM_USER + 13)
%RB_GETBANDINFO                                 = (%WM_USER + 29)
%RB_MOVEBAND                                    = (%WM_USER + 39)
%TTN_GETDISPINFO                                = %TTN_FIRST
%TTN_NEEDTEXT                                   = %TTN_GETDISPINFO
%SB_SETTEXT                                     = %WM_USER + 1
%SB_SETPARTS                                    = %WM_USER + 4
%TBS_NOTICKS                                    = &H0010
%TBS_FIXEDLENGTH                                = &H0040
%TBM_GETPOS                                     = %WM_USER
%TBM_SETPOS                                     = %WM_USER + 5
%TBM_SETRANGE                                   = %WM_USER + 6
%TBM_SETTICFREQ                                 = %WM_USER + 20
%TBM_SETPAGESIZE                                = %WM_USER + 21
%TBM_SETLINESIZE                                = %WM_USER + 23
%PBM_SETRANGE                                   = %WM_USER + 1
%PBM_SETPOS                                     = %WM_USER + 2
%PBM_DELTAPOS                                   = %WM_USER + 3
%PBM_SETSTEP                                    = %WM_USER + 4
%PBM_STEPIT                                     = %WM_USER + 5
%PBM_SETRANGE32                                 = %WM_USER + 6  ' lParam = high, wParam = low
%CCS_NORESIZE                                   = &H00000004&
%CCS_NODIVIDER                                  = &H00000040&

'-----------------------------------------------------------------
' TYPE and UNION structures:  13
'-----------------------------------------------------------------
TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE FILETIME
  dwLowDateTime AS DWORD
  dwHighDateTime AS DWORD
END TYPE

TYPE SYSTEMTIME
  wYear AS WORD
  wMonth AS WORD
  wDayOfWeek AS WORD
  wDay AS WORD
  wHour AS WORD
  wMinute AS WORD
  wSecond AS WORD
  wMilliseconds AS WORD
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS DWORD
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS DWORD
  dwReserved1 AS DWORD
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternateFileName AS ASCIIZ * 14
END TYPE

TYPE BITMAP
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS WORD
  bmBitsPixel AS WORD
  bmBits AS BYTE PTR
END TYPE

TYPE LOGFONT
  lfHeight AS LONG
  lfWidth AS LONG
  lfEscapement AS LONG
  lfOrientation AS LONG
  lfWeight AS LONG
  lfItalic AS BYTE
  lfUnderline AS BYTE
  lfStrikeOut AS BYTE
  lfCharSet AS BYTE
  lfOutPrecision AS BYTE
  lfClipPrecision AS BYTE
  lfQuality AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName AS ASCIIZ * %LF_FACESIZE
END TYPE

TYPE NMHDR
  hwndFrom AS DWORD
  idfrom AS DWORD
  code AS LONG    ' used for messages, so needs to be LONG, not DWORD...
END TYPE

TYPE TBBUTTON
  iBitmap AS LONG
  idCommand AS LONG
  fsState AS BYTE
  fsStyle AS BYTE
  bReserved(0 TO 1) AS BYTE
  dwData AS DWORD
  iString AS LONG
END TYPE

TYPE TBADDBITMAP
  hInst AS DWORD
  nID AS DWORD
END TYPE

TYPE TOOLTIPTEXT
  hdr AS NMHDR
  lpszText AS ASCIIZ PTR
  szText AS ASCIIZ * 80
  hinst AS DWORD
  uFlags AS DWORD
  lParam AS DWORD
END TYPE

TYPE INIT_COMMON_CONTROLSEX
    dwSize AS DWORD   ' size of this structure
    dwICC  AS DWORD   ' flags indicating which classes to be initialized
END TYPE

TYPE REBARINFO
    cbSize AS DWORD
    fMask  AS DWORD
    himl   AS DWORD
END TYPE

TYPE REBARBANDINFO
    cbSize     AS DWORD
    fMask      AS DWORD
    fStyle     AS DWORD
    clrFore    AS DWORD
    clrBack    AS DWORD
    lpText     AS ASCIIZ PTR
    cch        AS DWORD
    iImage     AS LONG
    hwndChild  AS DWORD
    cxMinChild AS DWORD
    cyMinChild AS DWORD
    cx         AS DWORD
    hbmBack    AS DWORD
    wID        AS DWORD
    cyChild    AS DWORD
    cyMaxChild AS DWORD
    cyIntegral AS DWORD
    cxIdeal    AS DWORD
    lParam     AS LONG
    cxHeader   AS DWORD
END TYPE

'-----------------------------------------------------------------
' Declared Functions:  40
'-----------------------------------------------------------------
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL dwRop AS DWORD) AS LONG
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" (BYVAL hdc AS DWORD, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS DWORD
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION CreateFontIndirect LIB "GDI32.DLL" ALIAS "CreateFontIndirectA" (lpLogFont AS LOGFONT) AS DWORD
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION EnableMenuItem LIB "USER32.DLL" ALIAS "EnableMenuItem" (BYVAL hMenu AS DWORD, BYVAL uIDEnableItem AS DWORD, BYVAL uEnable AS DWORD) AS LONG
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS DWORD
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetDateFormat LIB "KERNEL32.DLL" ALIAS "GetDateFormatA" (BYVAL Locale AS LONG, BYVAL dwFlags AS DWORD, lpDate AS SYSTEMTIME, lpFormat AS ASCIIZ, lpDateStr AS ASCIIZ, BYVAL cchDate AS LONG) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS DWORD
DECLARE FUNCTION GetDeviceCaps LIB "GDI32.DLL" ALIAS "GetDeviceCaps" (BYVAL hdc AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetModuleFileName LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameA" (BYVAL hModule AS DWORD, lpFileName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetObject LIB "GDI32.DLL" ALIAS "GetObjectA" (BYVAL hObject AS DWORD, BYVAL nCount AS LONG, lpObject AS ANY) AS LONG
DECLARE FUNCTION GetPrivateProfileString LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStringA" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS DWORD, lpFileName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSystemMenu LIB "USER32.DLL" ALIAS "GetSystemMenu" (BYVAL hWnd AS DWORD, BYVAL bRevert AS LONG) AS LONG
DECLARE FUNCTION GetTimeFormat LIB "KERNEL32.DLL" ALIAS "GetTimeFormatA" (BYVAL Locale AS LONG, BYVAL dwFlags AS DWORD, lpTime AS SYSTEMTIME, lpFormat AS ASCIIZ, lpTimeStr AS ASCIIZ, BYVAL cchTime AS LONG) AS LONG
DECLARE FUNCTION GetWindowLong LIB "USER32.DLL" ALIAS "GetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION ImageList_Add LIB "COMCTL32.DLL" ALIAS "ImageList_Add" _
    (BYVAL himl AS DWORD, BYVAL hbmImage AS DWORD, BYVAL hbmMask AS DWORD) _
    AS LONG
DECLARE FUNCTION ImageList_AddMasked LIB "COMCTL32.DLL" _
    ALIAS "ImageList_AddMasked" (BYVAL himl AS DWORD, _
    BYVAL hbmImage AS DWORD, BYVAL crMask AS DWORD) AS LONG
DECLARE FUNCTION ImageList_Create LIB "COMCTL32.DLL" ALIAS "ImageList_Create" _
    (BYVAL cx AS LONG, BYVAL cy AS LONG, BYVAL flags AS DWORD, _
    BYVAL cInitial AS LONG, BYVAL cGrow AS LONG) AS DWORD
DECLARE FUNCTION ImageList_Destroy LIB "COMCTL32.DLL" _
    ALIAS "ImageList_Destroy" (BYVAL himl AS DWORD) AS LONG
DECLARE FUNCTION InitCommonControlsEx LIB "COMCTL32.DLL" ALIAS "InitCommonControlsEx" (icc AS INIT_COMMON_CONTROLSEX) AS LONG
DECLARE FUNCTION IsClipboardFormatAvailable LIB "USER32.DLL" ALIAS "IsClipboardFormatAvailable" (BYVAL dwFormat AS DWORD) AS LONG
DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG) AS LONG
DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" (BYVAL hInst AS DWORD, lpsz AS ASCIIZ, BYVAL uType AS DWORD, BYVAL cxDesired AS LONG, BYVAL cyDesired AS LONG, BYVAL fuLoad AS DWORD) AS DWORD
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG, BYVAL uElapse AS DWORD, BYVAL lpTimerFunc AS LONG) AS LONG
DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS DWORD, lpOperation AS ASCIIZ, lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS DWORD
DECLARE FUNCTION WritePrivateProfileSection LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileSectionA" (lpAppName AS ASCIIZ, lpString AS ASCIIZ, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION WritePrivateProfileString LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStringA" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpString AS ASCIIZ, lpFileName AS ASCIIZ) AS LONG

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

%TBM_GETPOS      = %WM_USER
%TBS_NOTICKS     = &H0010???
%TBM_SETRANGE    = %WM_USER + 6
%TBM_SETPAGESIZE = %WM_USER + 21
%TBM_SETLINESIZE = %WM_USER + 23
%TBM_SETTICFREQ  = %WM_USER + 20
%TBM_SETPOS      = %WM_USER + 5
%TBS_FIXEDLENGTH = &H0040???

%PBM_SETRANGE    = %WM_USER + 1
%PBM_SETPOS      = %WM_USER + 2
%PBM_DELTAPOS    = %WM_USER + 3
%PBM_SETSTEP     = %WM_USER + 4
%PBM_STEPIT      = %WM_USER + 5
%PBM_SETRANGE32  = %WM_USER + 6  ' lParam = high, wParam = low

'==============================================================================
'= CONSTANTS AND EQUATES.
'==============================================================================
'= String Constants...
$APPTITLE       = "Template"
$APPINIFILENAME = "AppConf.ini"
$APPDBFILENAME  = "Data\"
$APPIDXFILENAME = "Data\"

'= Numeric Constants...
%ID_SBTIMER  = 4001

%ID_TEXT     =  10
%IDM_FILE    = 100
%IDM_NEW     = 101
%IDM_OPEN    = 102
%IDM_SAVE    = 103
%IDM_SAVEAS  = 104
%IDM_EXIT    = 109
%IDM_EDIT    = 120
%IDM_UNDO    = 121
%IDM_CUT     = 123
%IDM_COPY    = 124
%IDM_PASTE   = 125
%IDM_SELALL  = 126

'==============================================================================
'= UDT (USER DEFINED TYPES) STRUCTURES.
'==============================================================================
'= For saving and loading Applications Parameters - Add to this UDT for what
'= you want to save and re-load. Update ApParams.inc, for reading and writing!
'= Also look at the AppInitialize and AppTerminate Functions in this Module!
'==============================================================================
TYPE AppParametersTYPE
  sAppPath     AS STRING * %MAX_PATH      '= Applications Path.
  sAppIniPath  AS STRING * %MAX_PATH      '= Applications INI File Path.
  sAppDbPath   AS STRING * %MAX_PATH      '= Applications Database Path.
  sAppIdxPath  AS STRING * %MAX_PATH      '= Applications Database Index Path.
  sbDateFmt    AS LONG                    '= StatusBar Date Format.
  sbTimeFmt    AS LONG                    '= StatusBar Time Format.
  rbRowCount   AS LONG                    '= Rebar Number Of Rows.
  rbBandCount  AS LONG                    '= Rebar Number Of Bands.
  rbBand0      AS LONG                    '= Rebar Band 0 If Moved.
  rbBand1      AS LONG                    '= Rebar Band 1 If Moved.
  sbTimePart   AS LONG                    '= Statusbar Time Part (Panel) Number.
  sbDatePart   AS LONG                    '= StatusBar Date Part (Panel) Number.
END TYPE
GLOBAL udtAp AS AppParametersTYPE

'==============================================================================
'= GLOBAL VARIABLES.
'==============================================================================
GLOBAL hDlg     AS LONG           '= Applications Dialog Handle.
GLOBAL hEdit    AS LONG           '= Edit Control Handle NOT USED...
GLOBAL hMnu     AS LONG           '= Menu Handles.
GLOBAL hmnuFile AS LONG           '=
GLOBAL hmnuEdit AS LONG           '=
GLOBAL hmnuLang AS LONG           '=
GLOBAL hInst    AS LONG           '= Applications Instance Handle.

GLOBAL hRebar    AS DWORD         '= Handle To ReBar    Control.
GLOBAL hComboBox AS DWORD         '= Handle To ComboBox Control.
GLOBAL hToolBar  AS DWORD         '= Handle To ToolBar  Control.


'#INCLUDE "TOOLBAR.INC"
'==============================================================================
'= CONSTANTS AND EQUATES.
'==============================================================================
'= Number of Toolbar buttons to use.
%TOOLBUTTONS = 12

'= ReBar And ToolBar Equates. These All Start At 3000 And Are Incremented...
%ID_REBAR    = 3000
%ID_TOOLBAR  = 3001
%ID_COMBOBOX = 3002

'= These Are The ToolBar Button ID's.
%ID_NEW           = 101
%ID_OPEN          = 102
%ID_SAVE          = 103
%ID_PRINT         = 104
%ID_PRINTPREVIEW  = 105
%ID_CUT           = 106
%ID_COPY          = 107
%ID_PASTE         = 108
%ID_UNDOS         = 109
%ID_REDOS         = 110
%ID_UNDOC         = 111
%ID_REDOC         = 112
%ID_VIEW          = 113
%ID_EMAIL         = 114
%ID_FOLDERCLOSED  = 115
%ID_FOLDEROPEN    = 116
%ID_FOLDERS       = 117

'==============================================================================
'= UDT (USER DEFINED TYPES).
'==============================================================================

'==============================================================================
'= GLOBAL VARIABLES.
'==============================================================================

'= ToolBar ImageList Handles.
GLOBAL g_hImlHot AS DWORD
GLOBAL g_hImlDis AS DWORD
GLOBAL g_hImlSel AS DWORD

'= ToolBar Bitmap Handles.
GLOBAL g_hBmpHot AS DWORD
GLOBAL g_hBmpDis AS DWORD
GLOBAL g_hBmpSel AS DWORD

'= Rebar background Bitmap Handle.
GLOBAL g_hRbBack AS DWORD

'==============================================================================
'= FUNCTION AND SUB-ROUTINE DECLARATIONS.
'==============================================================================
DECLARE FUNCTION CreateRebar    (BYVAL hParent AS DWORD) AS LONG
DECLARE FUNCTION CreateComboBox (BYVAL hParent AS DWORD) AS DWORD
DECLARE FUNCTION CreateToolBar  (BYVAL hParent AS DWORD) AS DWORD

DECLARE FUNCTION SaveRebarBandPos() AS LONG

'= Function Declarations For Accessing Windows INI Files.
DECLARE FUNCTION ReadIniData(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING, _
                             BYVAL sKey AS STRING, BYVAL sDefault AS STRING)AS STRING
DECLARE FUNCTION WriteIniData(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING, _
                              BYVAL sKey AS STRING, BYVAL sValue AS STRING) AS LONG
DECLARE FUNCTION DeleteIniSection(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING) AS LONG
DECLARE FUNCTION DeleteIniKey(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING, BYVAL byvalsKey AS STRING) AS LONG

'= Function Declaration For Getting The Applications Path.
DECLARE FUNCTION GetAppPath() AS STRING

'= Disables The SysMenu And Dialog Close Button.
DECLARE FUNCTION DisableSysMenu(BYVAL hDlg AS DWORD) AS LONG

'= Creates A hFont For Use...
DECLARE FUNCTION MakeFont(BYVAL sFntName AS STRING, BYVAL fFntSize AS LONG, _
                          BYVAL lWeight AS LONG, BYVAL lUnderlined AS LONG, _
                          BYVAL lItalic AS LONG, BYVAL lStrike AS LONG, _
                          BYVAL lCharSet AS LONG) AS DWORD

'= Execute Another Program...
DECLARE FUNCTION ExeFile(BYVAL CmdString AS STRING, BYVAL WndStyle AS LONG) AS LONG
                           
'==============================================================================
'= DECLARED GLOBALS.
'==============================================================================

GLOBAL gAppPath AS STRING              '= Applications Path.
GLOBAL gIniPath AS STRING              '= Ini File Path.

FUNCTION ReadIniData(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING, _
                     BYVAL sKey AS STRING, BYVAL sDefault AS STRING) AS STRING

  LOCAL lResult  AS LONG
  LOCAL zSection AS ASCIIZ * 125
  LOCAL zKey     AS ASCIIZ * 125
  LOCAL zData    AS ASCIIZ * 150
  LOCAL zDefault AS ASCIIZ * 150
  LOCAL zIniFile AS ASCIIZ * 255

  zSection = sSection
  zKey     = sKey
  zIniFile = sIniFile
  zDefault = sDefault
  
  
  lResult = GetPrivateProfileString(zSection, zKey, zDefault, zData, SIZEOF(zData), zIniFile)
  
  FUNCTION = zData
  
END FUNCTION

'==============================================================================
'= FUNCTION: WriteIniData()
'==============================================================================
FUNCTION WriteIniData(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING, _
                      BYVAL sKey AS STRING, BYVAL sValue AS STRING) AS LONG

  LOCAL zSection AS ASCIIZ * 125
  LOCAL zKey     AS ASCIIZ * 125
  LOCAL zValue   AS ASCIIZ * 150
  LOCAL zIniFile AS ASCIIZ * 255

  zSection = sSection
  zKey     = sKey
  zIniFile = sIniFile
  zValue   = TRIM$(sValue)

  FUNCTION = WritePrivateProfileString(zSection, zKey, zValue, zIniFile)

END FUNCTION

'==============================================================================
'= FUNCTION: DeleteIniSection()
'==============================================================================
'= Usage: call DeleteIniKey("MyIniFile.ini","CODE","PATH03")
'==============================================================================
FUNCTION DeleteIniSection(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING) AS LONG

  LOCAL zSection AS ASCIIZ * 125
  LOCAL zIniFile AS ASCIIZ * 255

  zSection = sSection
  zIniFile = sIniFile

  FUNCTION = WritePrivateProfileSection(zSection, BYVAL %NULL, zIniFile)

END FUNCTION

'==============================================================================
'= FUNCTION: DeleteIniKey()
'==============================================================================
FUNCTION DeleteIniKey(BYVAL sIniFile AS STRING, BYVAL sSection AS STRING, BYVAL sKey AS STRING) AS LONG

  LOCAL zSection AS ASCIIZ * 125
  LOCAL zKey     AS ASCIIZ * 125
  LOCAL zIniFile AS ASCIIZ * 255

  zSection = sSection
  zKey     = sKey
  zIniFile = sIniFile

  FUNCTION = WritePrivateProfileString(zSection, zKey, BYVAL %NULL, zIniFile)

END FUNCTION

'==============================================================================
'= FUNCTION: GetAppPath()
'==============================================================================
FUNCTION GetAppPath() AS STRING

  LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH

  GetModuleFileName GetModuleHandle(BYVAL %NULL), TmpAsciiz, 260

  FUNCTION = LEFT$(TmpAsciiz, INSTR(-1, TmpAsciiz, ANY "\/:"))

END FUNCTION

'==============================================================================
'= FUNCTION: FileExist - make sure a file or folder exists
'==============================================================================
FUNCTION FileExist(BYVAL sfName AS STRING) AS LONG

  LOCAL hRes AS DWORD
  LOCAL tWFD AS WIN32_FIND_DATA

  IF LEN(sfName) = 0 THEN EXIT FUNCTION       '= no need to continue then..

  IF ASC(sfName, -1) = 92 THEN                '= if a path with trailing backslash
    sfName = LEFT$(sfName, LEN(sfName) - 1)   '= remove trailing backslash
  END IF

  hRes = FindFirstFile(BYVAL STRPTR(sfName), tWFD)

  IF hRes <> %INVALID_HANDLE_VALUE THEN
    FUNCTION = %TRUE
    FindClose hRes
  END IF

END FUNCTION

FUNCTION DisableSysMenu(BYVAL hDlg AS DWORD) AS LONG

  LOCAL SysMenu AS DWORD
  
  SysMenu = GetSystemMenu(hDlg, %FALSE) '= window's system menu.

  EnableMenuItem SysMenu, %SC_CLOSE, %MF_BYCOMMAND OR %MF_DISABLED

END FUNCTION


FUNCTION MakeFont(BYVAL sFntName AS STRING, BYVAL fFntSize    AS LONG, _
                  BYVAL lWeight  AS LONG,   BYVAL lUnderlined AS LONG, _
                  BYVAL lItalic  AS LONG,   BYVAL lStrike     AS LONG, _
                  BYVAL lCharSet AS LONG)   AS DWORD
                                  
'==============================================================================
'= Examples of Use:
'=
'=    hFont = MakeFont("MS Sans Serif", 8, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET)
'=    hFont = MakeFont("Courier New", 10, %FW_BOLD, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET)
'=    hFont = MakeFont("Marlett", 8, %FW_NORMAL, %FALSE, %FALSE, %FALSE, %SYMBOL_CHARSET)
'=
'= Note: Any font created with MakeFont should also be destroyed with DeleteObject
'=       when no longer needed to prevent memory leaks.  For example:
'=
'=        Case %WM_DESTROY
'=            DeleteObject hFont
'==============================================================================
        
  DIM lf          AS LOGFONT
  DIM hDC         AS DWORD
  DIM lCyPixels   AS LONG

  hDC         = GetDC(%HWND_DESKTOP)
  lCyPixels   = GetDeviceCaps(hDC, %LOGPIXELSY)
  ReleaseDC %HWND_DESKTOP, hDC

  lf.lfHeight         = -(fFntSize * lCyPixels) \ 72
  lf.lfFaceName       = sFntName
  lf.lfPitchAndFamily = %FF_DONTCARE
  
  IF lWeight = %FW_DONTCARE THEN
     lf.lfWeight = %FW_NORMAL
  ELSE
     lf.lfWeight = lWeight
  END IF
  
  lf.lfUnderline  = lUnderlined
  lf.lfItalic     = lItalic
  lf.lfStrikeOut  = lStrike
  lf.lfCharSet    = lCharSet
    
  FUNCTION = CreateFontIndirect(lf)
    
END FUNCTION

FUNCTION ExecuteURL(BYVAL sText AS STRING) AS LONG

  STATIC zText    AS ASCIIZ * 128
  
  zText = sText
  
  ShellExecute BYVAL %NULL, "open", zText, BYVAL %NULL, BYVAL %NULL, %SW_SHOWNORMAL 
   
END FUNCTION

FUNCTION ExeFile(BYVAL CmdString AS STRING, BYVAL WndStyle AS LONG) AS LONG
  
  LOCAL sErr AS STRING, lResult AS LONG, sExe AS STRING
  
  ON ERROR RESUME NEXT
 
  sExe = GetAppPath & CmdString
   
  SHELL sExe, WndStyle
  
  IF ERR THEN
    sErr = ERROR$
    lResult = MSGBOX(sErr, %MB_ICONERROR OR %MB_OKCANCEL, "Application Error")
    ERRCLEAR
    FUNCTION = %FALSE
    EXIT FUNCTION
  END IF
  
  FUNCTION = %TRUE
  
END FUNCTION

FUNCTION AppSaveParams() AS LONG
  
  '= INI Section [Application].
  WriteIniData udtAp.sAppIniPath, "APPLICATION PATHS", "APPPATH",    udtAp.sAppPath
  WriteIniData udtAp.sAppIniPath, "APPLICATION PATHS", "APPINIPATH", udtAp.sAppIniPath
  WriteIniData udtAp.sAppIniPath, "APPLICATION PATHS", "APPDBPATH",  udtAp.sAppDbPath
  WriteIniData udtAp.sAppIniPath, "APPLICATION PATHS", "APPIDXPATH", udtAp.sAppIdxPath
  
  '= INI Section [DATETIMEFORMAT].
  WriteIniData udtAp.sAppIniPath, "DATE TIME FORMAT", "SBDATEFMT",  STR$(udtAp.sbDateFmt)
  WriteIniData udtAp.sAppIniPath, "DATE TIME FORMAT", "SBTIMEFMT",  STR$(udtAp.sbTimeFmt)
  WriteIniData udtAp.sAppIniPath, "DATE TIME FORMAT", "SBDATEPART", STR$(udtAp.sbDatePart)
  WriteIniData udtAp.sAppIniPath, "DATE TIME FORMAT", "SBTIMEPART", STR$(udtAp.sbTimePart)
  
  '= INI Section [REBAR POSITIONS].
  WriteIniData udtAp.sAppIniPath, "REBAR POSITIONS", "RBROWS",  STR$(udtAp.rbRowCount)
  WriteIniData udtAp.sAppIniPath, "REBAR POSITIONS", "RBBANDS", STR$(udtAp.rbBandCount)
  WriteIniData udtAp.sAppIniPath, "REBAR POSITIONS", "RBBAND0", STR$(udtAp.rbBand0)
  WriteIniData udtAp.sAppIniPath, "REBAR POSITIONS", "RBBAND1", STR$(udtAp.rbBand1)
  
END FUNCTION

FUNCTION AppLoadParams() AS LONG

  '= INI Section [Application].
  udtAp.sAppPath    = ReadIniData(udtAp.sAppIniPath, "APPLICATION PATHS", "APPPATH",    "")
  udtAp.sAppIniPath = ReadIniData(udtAp.sAppIniPath, "APPLICATION PATHS", "APPINIPATH", "")
  udtAp.sAppDbPath  = ReadIniData(udtAp.sAppIniPath, "APPLICATION PATHS", "APPDBPATH",  "")
  udtAp.sAppIdxPath = ReadIniData(udtAp.sAppIniPath, "APPLICATION PATHS", "APPIDXPATH", "")
  
  '= INI Section [DATETIMEFORMAT].
  udtAp.sbDateFmt  = VAL(ReadIniData(udtAp.sAppIniPath, "DATE TIME FORMAT", "SBDATEFMT", ""))
  udtAp.sbTimeFmt  = VAL(ReadIniData(udtAp.sAppIniPath, "DATE TIME FORMAT", "SBTIMEFMT", ""))
  udtAp.sbDatePart = VAL(ReadIniData(udtAp.sAppIniPath, "DATE TIME FORMAT", "SBDATEPART", ""))
  udtAp.sbTimePart = VAL(ReadIniData(udtAp.sAppIniPath, "DATE TIME FORMAT", "SBTIMEPART", ""))
  
  '= INI Section [REBAR POSITIONS].
  udtAp.rbRowCount  = VAL(ReadIniData(udtAp.sAppIniPath, "REBAR POSITIONS", "RBROWS",  ""))
  udtAp.rbBandCount = VAL(ReadIniData(udtAp.sAppIniPath, "REBAR POSITIONS", "RBBANDS", ""))
  udtAp.rbBand0     = VAL(ReadIniData(udtAp.sAppIniPath, "REBAR POSITIONS", "RBBAND0", ""))
  udtAp.rbBand1     = VAL(ReadIniData(udtAp.sAppIniPath, "REBAR POSITIONS", "RBBAND1", ""))
  
END FUNCTION

FUNCTION CreateToolBar(BYVAL hParent AS DWORD) AS DWORD

  '= General Register variables for speed optimization
  REGISTER x AS LONG
  
  LOCAL bm   AS BITMAP
  
  '= Toolbar variables
  LOCAL Tbb() AS TBBUTTON
  LOCAL Tabm  AS TBADDBITMAP
  
  DIM Tbb(0 TO %TOOLBUTTONS - 1) AS LOCAL TBBUTTON

  CONTROL ADD "ToolbarWindow32", hParent, %ID_TOOLBAR, "", 0, 0, 0, 0, _
       %WS_CHILD OR %WS_VISIBLE OR %TBSTYLE_TOOLTIPS OR %TBSTYLE_FLAT OR %TBSTYLE_TRANSPARENT _
       OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS OR %CCS_NORESIZE OR %CCS_NODIVIDER 
  
  '============================================================================
  '= Setup And Initialize The ToolBar Bitmaps And ImageLists.
  '============================================================================
  '= Normal Hot Bitmap.
  g_hBmpHot = LoadImage(GetModuleHandle(""), "TBHOT", %IMAGE_BITMAP, 0, 0, _
                       %LR_LOADTRANSPARENT OR %LR_LOADMAP3DCOLORS OR %LR_DEFAULTSIZE)
  '= Disabled Bitmap.
  g_hBmpDis = LoadImage(GetModuleHandle(""), "TBDIS", %IMAGE_BITMAP, 0, 0, _
                       %LR_LOADTRANSPARENT OR %LR_LOADMAP3DCOLORS OR %LR_DEFAULTSIZE)
  '= Selected Bitmap.
  g_hBmpSel = LoadImage(GetModuleHandle(""), "TBSEL", %IMAGE_BITMAP, 0, 0, _
                       %LR_LOADTRANSPARENT OR %LR_LOADMAP3DCOLORS OR %LR_DEFAULTSIZE)
  
  GetObject g_hBmpHot, SIZEOF(bm), bm           '= Get The Bitmap's Sizes.
  
  '= ToolBar ImageLists Hot, Disabled and Normal.
  g_hImlHot = ImageList_Create(16, 16, %ILC_COLORDDB OR %ILC_MASK, 1, 0)
              ImageList_AddMasked g_hImlHot, g_hBmpHot, RGB(255,0,255)
              ImageList_Add g_hImlHot, g_hBmpHot, RGB(255,0,255)
              
  g_hImlDis = ImageList_Create(16, 16, %ILC_COLORDDB OR %ILC_MASK, 1, 0)
              ImageList_AddMasked g_hImlDis, g_hBmpDis, RGB(255,0,255)
              ImageList_Add g_hImlDis, g_hBmpDis, RGB(255,0,255)
              
  g_hImlSel = ImageList_Create(16, 16, %ILC_COLORDDB OR %ILC_MASK, 1, 0)
              ImageList_AddMasked g_hImlSel, g_hBmpSel, RGB(255,0,255)
              ImageList_Add g_hImlSel, g_hBmpSel, RGB(255,0,255)
  
  '= Clean-up no longer needed...
  DeleteObject(g_hBmpHot)
  DeleteObject(g_hBmpDis)
  DeleteObject(g_hBmpSel)
                  
  '= Init Tbb array of Buttons.
  FOR x = 0 TO %TOOLBUTTONS - 1
    '= Set the initial states for each button
    Tbb(x).iBitmap = 0
    Tbb(x).idCommand = 0
    Tbb(x).fsState = %TBSTATE_ENABLED
    Tbb(x).fsStyle = %TBSTYLE_BUTTON OR %TBSTYLE_AUTOSIZE 
    Tbb(x).dwData = 0
    Tbb(x).iString = 0

    SELECT CASE AS LONG x
      CASE 3,6,10
        '= Gap creation buttons.
        Tbb(x).fsStyle   = %TBSTYLE_SEP
      
      CASE 0&
        Tbb(x).iBitmap   = 0
        Tbb(x).idCommand = %ID_NEW
        Tbb(x).iString   = 0
        Tbb(x).fsState   = %TBSTATE_ENABLED ' Would be %TBSTATE_DISABLED if defined
        
      CASE 1&
        Tbb(x).iBitmap   = 1
        Tbb(x).idCommand = %ID_OPEN
        Tbb(x).iString   = 1
        Tbb(x).fsState   = %TBSTATE_ENABLED ' Would be %TBSTATE_DISABLED if defined

      CASE 2&
        Tbb(x).iBitmap   = 2
        Tbb(x).idCommand = %ID_SAVE
        Tbb(x).iString   = 2

      CASE 4&
        Tbb(x).iBitmap   = 3
        Tbb(x).idCommand = %ID_PRINT
        Tbb(x).iString   = 3
        Tbb(x).fsState   = %TBSTATE_ENABLED
        
      CASE 5&
        Tbb(x).iBitmap   = 4
        Tbb(x).idCommand = %ID_PRINTPREVIEW
        Tbb(x).iString   = 3 
        
      CASE 7&
        Tbb(x).iBitmap   = 5
        Tbb(x).idCommand = %ID_CUT
        Tbb(x).iString   = 4
      
      CASE 8&
        Tbb(x).iBitmap   = 6
        Tbb(x).idCommand = %ID_COPY
        Tbb(x).iString   = 5
        
      CASE 9&
        Tbb(x).iBitmap   = 7
        Tbb(x).idCommand = %ID_PASTE
        Tbb(x).iString   = 6
      
      CASE 11&
        Tbb(x).iBitmap   = 13
        Tbb(x).idCommand = %ID_EMAIL
        Tbb(x).iString   = 7
          
    END SELECT
  NEXT x

  Tabm.nID   = %ID_TOOLBAR '%IDB_STD_LARGE_COLOR ' Use the ID of the bitmap image, ie, %ID_TOOLBAR
  Tabm.hInst =  GetModuleHandle(BYVAL %NULL)   ' %HINST_COMMCTRL
                                               ' if using a bitmap in a linked resource file
  
  '= Add The ImageLists to the ToolBar.                                  
  CONTROL SEND hParent, %ID_TOOLBAR, %TB_SETIMAGELIST, 0, g_hImlHot
  CONTROL SEND hParent, %ID_TOOLBAR, %TB_SETDISABLEDIMAGELIST, 0, g_hImlDis
  CONTROL SEND hParent, %ID_TOOLBAR, %TB_SETHOTIMAGELIST, 0, g_hImlSel
  
  '= Set the imge list for the TB
  CONTROL SEND hParent, %ID_TOOLBAR, %TB_ADDBITMAP, %ToolButtons, VARPTR(Tabm)

  '= Set the buttons
  CONTROL SEND hParent, %ID_TOOLBAR, %TB_BUTTONSTRUCTSIZE, SIZEOF(Tbb(0)), 0
  CONTROL SEND hParent, %ID_TOOLBAR, %TB_ADDBUTTONS, %ToolButtons, VARPTR(Tbb(0))

  CONTROL HANDLE hParent, %ID_TOOLBAR TO hToolBar

  FUNCTION = hToolBar

END FUNCTION

FUNCTION CreateRebar (BYVAL hParent AS DWORD) AS LONG

  LOCAL rbi       AS REBARINFO
  LOCAL rbBand    AS REBARBANDINFO
  LOCAL rc        AS RECT
  LOCAL hCbBox    AS DWORD
  LOCAL szCbText  AS ASCIIZ * 255
  LOCAL hTbBar    AS DWORD
  LOCAL szTbText  AS ASCIIZ * 255
  LOCAL dwBtnSize AS DWORD

  CONTROL ADD "ReBarWindow32", hParent, %ID_REBAR, "", 0, 0, 0, 0, _
      %WS_BORDER OR %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN OR _
      %RBS_VARHEIGHT OR %RBS_BANDBORDERS OR %RBBS_FIXEDSIZE'OR %CCS_NODIVIDER
           
  CONTROL HANDLE hParent, %ID_REBAR TO hRebar
  
  g_hRbBack = LoadImage(GetModuleHandle(""), "RBBACK", %IMAGE_BITMAP, 0, 0, _
                        %LR_LOADTRANSPARENT OR %LR_LOADMAP3DCOLORS OR %LR_DEFAULTSIZE)
                       
  '= Initialize and send the REBARINFO structure
  rbi.cbSize = SIZEOF(rbi)
  rbi.fMask  = 0
  rbi.himl   = 0

  CONTROL SEND hParent, %ID_REBAR, %RB_SETBARINFO, 0, VARPTR(rbi)

  '= Initialize REBARBANDINFO for all rebar bands
  rbBand.cbSize     = SIZEOF(rbBand)
  rbBand.fMask      = %RBBIM_COLORS    OR _    '= clrFore and clrBack are valid
                      %RBBIM_CHILD     OR _    '= hwndChild is valid
                      %RBBIM_CHILDSIZE OR _    '= cxMinChild and cyMinChild are valid
                      %RBBIM_STYLE     OR _    '= fStyle is valid
                      %RBBIM_ID        OR _    '= wID is valid
                      %RBBIM_SIZE      OR _    '= cx is valid
                      %RBBIM_TEXT      OR _    '= lpText is valid
                      %RBBIM_BACKGROUND        '= hbmBack is valid
  rbBand.clrFore    = GetSysColor(%COLOR_BTNTEXT)
  rbBand.clrBack    = GetSysColor(%COLOR_BTNFACE)
  
  rbBand.fStyle = %RBBS_NOVERT     OR _    '= do not display in vertical orientation
                  %RBBS_CHILDEDGE  OR _
                  %RBBS_FIXEDBMP   OR _
                  %RBBS_GRIPPERALWAYS
  
  rbBand.hbmBack    = g_hRbBack
  
  '= Create The Rebar ToolBar Band.
  hTbBar            = CreateToolBar(hDlg)
  dwBtnSize         = SendMessage(hTbBar, %TB_GETBUTTONSIZE, 0, 0)
  'szTbText          = "ToolBar"
  'rbBand.lpText     = VARPTR(szTbText)
  rbBand.hwndChild  = hTbBar
  rbBand.wID        = %ID_TOOLBAR
  rbBand.cxMinChild = 230
  rbBand.cyMinChild = HIWRD(dwBtnSize)
  rbBand.cx         = 280
  
  '= Break the Band to a New Row is more then one.
  IF udtAp.rbRowCount > 1 THEN
    rbBand.fStyle = rbBand.fStyle OR %RBBS_BREAK
  END IF
  '= Insert band into rebar
  CONTROL SEND hParent, %ID_REBAR, %RB_INSERTBAND, 0&, VARPTR(rbBand)
    
  '= Create The Rebar ComboBox Band.  
  hCbBox = CreateComboBox(hDlg)

  szCbText          = " ComboBox: "
  rbBand.lpText     = VARPTR(szCbText)
  rbBand.hwndChild  = hCbBox
  rbBand.wID        = %ID_COMBOBOX
  GetWindowRect hCbBox, rc
  rbBand.cxMinChild = 150
  rbBand.cyMinChild = rc.nBottom - rc.nTop
  rbBand.cx         = 460

  '= Insert band into rebar
  CONTROL SEND hParent, %ID_REBAR, %RB_INSERTBAND, 1&, VARPTR(rbBand)
  
  '= Move Rebar Bands that were Saved!
  IF udtAp.rbBand0 <> %ID_TOOLBAR THEN SendMessage hRebar, %RB_MOVEBAND, 1&, 0&
  
END FUNCTION

FUNCTION CreateComboBox (BYVAL hParent AS DWORD) AS DWORD

  REGISTER i AS LONG

  CONTROL ADD COMBOBOX, hParent, %ID_COMBOBOX,, 0, 0, 0, 200, _
      %WS_CHILD OR %WS_VISIBLE OR %CBS_DROPDOWNLIST OR %WS_VSCROLL _
      OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN
  CONTROL HANDLE hParent, %ID_COMBOBOX TO hComboBox
  
  FOR i = 1 TO 20
    COMBOBOX ADD hParent, %ID_COMBOBOX, "Item " & FORMAT$(i)
  NEXT
  
  COMBOBOX SELECT hParent, %ID_COMBOBOX, 1
  
  FUNCTION = hComboBox

END FUNCTION

FUNCTION SaveRebarBandPos() AS LONG
  
  DIM lResult AS LONG, lBands AS LONG
  DIM rBand   AS REBARBANDINFO
  
  REGISTER lCount AS LONG

  '= Get the Rebar Number of Rows.
  lResult = SendMessage(hRebar, %RB_GETROWCOUNT, 0&, 0&)
  udtAp.rbRowCount = lResult
  
  '= Get the Rebar Number of Bands.
  lBands = SendMessage(hRebar, %RB_GETBANDCOUNT, 0&, 0&)
  udtAp.rbBandCount = lResult
  
  '= Setup the Rebar REBARBANDINFO Structure.
  rBand.cbSize = SIZEOF(rBand)
  rBand.fMask  = %RBBIM_ID

  '= Loop thru and get the Band ID's.    
  FOR lCount = 0 TO lBands - 1
    'lResult = SendMessage(hRebar, %RB_IDTOINDEX, lCount, VARPTR(rBand))
    lResult = SendMessage(hRebar, %RB_GETBANDINFO, lCount, VARPTR(rBand))
    IF lCount = 0 THEN udtAp.rbBand0 = rBand.Wid
    IF lCount = 1 THEN udtAp.rbBand1 = rBand.Wid
  NEXT
  
END FUNCTION

'#INCLUDE "STATUSBAR.INC"
'==============================================================================
'= CONSTANTS AND EQUATES.
'==============================================================================
'= StaysBar ID.
%ID_STATUSBAR  = 4000
%ID_PROGRESS   = 4001
%ID_TRACKBAR   = 4002

'= StatusBar DATE MASKS.
%SB_DATENORMAL = 0                '= Normal Date MM-DD-YYYY.
%SB_DATESHORT  = 1                '= Short  Date Mar 7, 2003.
%SB_DATELONG   = 2                '= Long   Date March 7, 2003.

'= StatusBar TIME MASKS.
%SB_TIMENORMAL = 0                '= Normal Time 00:00:00
%SB_TIMELONG   = 1                '= Long   Time 00:00:00 AM/PM.
%SB_TIMESHORT  = 2                '= Short  Time 00:00    AM/PM.

'==============================================================================
'= UDT (USER DEFINED TYPES).
'==============================================================================

'==============================================================================
'= GLOBAL VARIABLES.
'==============================================================================
GLOBAL hStatus    AS DWORD         '= StatusBar Handle.
GLOBAL sbParts()  AS LONG          '= StatusBar Parts Array.
GLOBAL sbText()   AS ASCIIZ * 128  '= StatusBar Text Aray.
GLOBAL sbMonths() AS STRING * 9    '= Holds The Months For Dates.
GLOBAL g_hSbFont  AS DWORD         '= StatusBar Font Handle.

'==============================================================================
'= FUNCTION AND SUB-ROUTINE DECLARATIONS.
'==============================================================================
DECLARE FUNCTION SBarDate(BYVAL lPart AS LONG, BYVAL lType AS LONG, _
                          BYVAL lDateMask AS LONG) AS LONG
DECLARE FUNCTION SBarTime(BYVAL lPart AS LONG, BYVAL lType AS LONG, _
                          BYVAL lTimeMask AS LONG) AS LONG

DECLARE FUNCTION SBarText(BYVAL lPart AS LONG, BYVAL lType AS LONG, _
                          BYVAL sText AS STRING) AS LONG

                             
'==============================================================================
'= APPLICATIONS STATUSBAR - FUNCTIONS AND SUB-ROUTINES.
'==============================================================================
FUNCTION SBarSize(BYVAL hDlg AS LONG) AS LONG

  LOCAL lResult AS LONG
  LOCAL lpRect  AS RECT

  '= Get The StatusBars Rect For Calculating Its Client Width.
  GetClientRect(hDlg, lpRect)

  sbParts(0) = lpRect.nRight - 220
  sbParts(1) = lpRect.nRight - 120
  sbParts(2) = lpRect.nRight - 1
  'sbParts(3) = -1
    
  lResult = SendMessage(hStatus, %SB_SETPARTS, 4, VARPTR(sbParts(0)))
  
END FUNCTION

FUNCTION SBarDate(BYVAL lPart AS LONG, BYVAL lType AS LONG, _
                  BYVAL lDateMask AS LONG) AS LONG
  
  LOCAL lFlags AS LONG
  LOCAL sTemp  AS ASCIIZ * 20
  LOCAL zText  AS ASCIIZ * %MAX_PATH  
  
  lFlags = lPart OR lType       '= Combine Part Number And Styles.
  
  '============================================================================
  '= Return New Formated Date Depending On The Users Selection Date Mask.
  '============================================================================
  SELECT CASE lDateMask
    CASE %SB_DATENORMAL                '= Normal Date MM-DD-YYYY.
      sTemp = "MM dd, yyyy"
    CASE %SB_DATESHORT                 '= Short  Date Mar 7, 2003.
      sTemp = "MMM dd, yyyy"
    CASE %SB_DATELONG                  '= Long   Date March 7, 2003.
      sTemp = "MMMM dd, yyyy"
  END SELECT
  
  GetDateFormat %LOCALE_USER_DEFAULT, 0, BYVAL %NULL, BYCOPY sTemp, zText, SIZEOF(zText)
  
  sbText(lPart) = $TAB & zText      
  'sbText(lPart) = zText      
  SendMessage hStatus, %SB_SETTEXT, lFlags, VARPTR(sbText(lPart))
    
END FUNCTION

FUNCTION SBarTime(BYVAL lPart AS LONG, BYVAL lType AS LONG, _
                  BYVAL lTimeMask AS LONG) AS LONG
  
  LOCAL lFlags AS LONG
  LOCAL sTemp  AS ASCIIZ * 20  
  LOCAL zText  AS ASCIIZ * %MAX_PATH
  
  lFlags = lPart OR lType       '= Combine Part Number And Styles.
    
  '============================================================================
  '= Return New Formated Time Depending On The Users Selection Time Mask.
  '============================================================================  
  SELECT CASE lTimeMask
    CASE %SB_TIMENORMAL           '= Normal Time 00:00:00
      sTemp = "HH:mm:ss"
    CASE %SB_TIMELONG             '= Long   Time 00:00:00 AM/PM.
      sTemp = "h:mm:ss tt"
    CASE %SB_TIMESHORT            '= Short  Time 00:00    AM/PM.
      sTemp = "h:mm tt"
  END SELECT
  
  GetTimeFormat %LOCALE_USER_DEFAULT, 0, BYVAL %NULL, BYCOPY sTemp, zText, SIZEOF(zText)
  
  sbText(lPart) = $TAB & zText
  'sbText(lPart) = zText
  SendMessage hStatus, %SB_SETTEXT, lFlags, VARPTR(sbText(lPart))
  
END FUNCTION

'==============================================================================
'= FUNCTION : SBarPanelText(BYVAL sText AS STRING) AS LONG
'= DESC     : Displays The StatusBar Text in a part (Panel).
'==============================================================================
'= PARAMS   : lPart - The StatusBar Part (Panel) number to use.
'=          : lType - The Part (Panel) Type (Style) of Borders etc.
'=          : sText - The Text to display in the StatusBar Part (Panel).
'==============================================================================
'= RETURNS  : NONE
'==============================================================================
'= NOTES    : lType = OR'ed
'= 0                - The text is drawn with a border to appear lower than the
'=                    plane of the window.
'= %SBT_NOBORDERS   - The text is drawn without borders.
'= %SBT_OWNERDRAW   - The text is drawn by the parent window.
'= %SBT_POPOUT      - The text is drawn with a border to appear higher than the
'=                    plane of the window.
'= %SBT_RTLREADING  - The text will be displayed in the opposite direction to
'=                    the text in the parent window.
'==============================================================================
FUNCTION SBarText(BYVAL lPart AS LONG, BYVAL lType AS LONG, _
                  BYVAL sText AS STRING) AS LONG
  
  LOCAL lFlags AS LONG          '= Combined Part Number And Styles.
  
  lFlags = lPart OR lType       '= Combine Part Number And Styles.
  
  sbText(lPart) = sText         '= StatusBar Part (Panel) Number to set Text.
  
  '= Set the StatusBar Font.
  SendMessage hStatus,%WM_SETFONT, g_hSbFont, 0
  
  '= Set the StatusBar Text...
  SendMessage hStatus, %SB_SETTEXT, lFlags, VARPTR(sbText(lPart))
  
END FUNCTION

'==============================================================================
'= FUNCTION AND SUB-ROUTINE DECLARATIONS.
'==============================================================================
DECLARE CALLBACK FUNCTION DlgProc

DECLARE FUNCTION AppTerminate(BYVAL hDlg AS DWORD) AS LONG

DECLARE FUNCTION GetMenuTxt(BYVAL ItemId AS LONG) AS STRING
DECLARE FUNCTION SetMenuBitmap (BYVAL bNum AS LONG) AS LONG

DECLARE SUB MenuEditSet(BYVAL wParam AS LONG)

'==============================================================================
'= APPLICATIONS MAIN ENTRY POINT.
'==============================================================================
FUNCTION PBMAIN

  LOCAL lResult AS LONG, sSkin AS STRING
  LOCAL CC1     AS INIT_COMMON_CONTROLSEX

  hInst = GetModuleHandle(BYVAL %NULL)

  '= Initialize the common control library.
  CC1.dwSize = SIZEOF(CC1)
  CC1.dwICC  = %ICC_WIN95_CLASSES OR %ICC_COOL_CLASSES

  InitCommonControlsEx CC1

  '= No Error Trapping, We Will Handle It Ourselves.
  ON ERROR RESUME NEXT

  DIALOG NEW 0, $APPTITLE, 0, 0, 420, 300, %WS_CAPTION OR %WS_CLIPCHILDREN OR _
                %WS_MAXIMIZEBOX OR %WS_MINIMIZEBOX OR %WS_SYSMENU OR %DS_CENTER, _
                TO hDlg

  '= Assign An Icon To Our Dialog Caption.
  DIALOG SET ICON hDlg, "PROGRAM"

  '= Build The Menu.
  MENU NEW BAR TO hMnu

  MENU NEW POPUP TO hmnuFile
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_NEW),     %IDM_NEW,    %MF_ENABLED
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_OPEN),    %IDM_OPEN,   %MF_ENABLED
     MENU ADD STRING, hMnuFile, "-", 0, 0
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_SAVE),    %IDM_SAVE,   %MF_ENABLED
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_SAVEAS),  %IDM_SAVEAS, %MF_ENABLED
     MENU ADD STRING, hMnuFile, "-", 0, 0
     MENU ADD STRING, hMnuFile, GetMenuTxt(%IDM_EXIT),    %IDM_EXIT,   %MF_ENABLED
     MENU ADD POPUP, hMnu, GetMenuTxt(%IDM_FILE), hmnuFile, %MF_ENABLED

  MENU NEW POPUP TO hmnuEdit
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_UNDO),    %IDM_UNDO,   %MF_ENABLED
     MENU ADD STRING, hMnuEdit, "-", 0, 0
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_CUT),     %IDM_CUT,    %MF_ENABLED
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_COPY),    %IDM_COPY,   %MF_ENABLED
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_PASTE),   %IDM_PASTE,  %MF_ENABLED
     MENU ADD STRING, hMnuEdit, "-", 0, 0
     MENU ADD STRING, hmnuEdit, GetMenuTxt(%IDM_SELALL),  %IDM_SELALL, %MF_ENABLED
     MENU ADD POPUP, hMnu, GetMenuTxt(%IDM_EDIT), hmnuEdit, %MF_ENABLED
  MENU ATTACH hMnu, hDlg

  DIALOG SHOW MODAL hDlg CALL DlgProc

END FUNCTION

'==============================================================================
'= APPLICATIONS MAIN CALLBACK PROCEDURE.
'==============================================================================
CALLBACK FUNCTION DlgProc

  REGISTER  x         AS LONG
  LOCAL     hMnu      AS DWORD            '= Main MenuBars Handle.
  LOCAL     pTOOLTIP  AS TOOLTIPTEXT PTR  '= Structure pointer via NMHDR
  STATIC    szTipText AS ASCIIZ * 64      '= ToolTips text buffer
  LOCAL     hIcon     AS LONG
  LOCAL     rc        AS RECT

  SELECT CASE CBMSG
    CASE %WM_INITDIALOG
      '============================================================================
      '= Load All Of The Application Parameters From The Applications INI File.
      '============================================================================
      udtAp.sAppPath    = GetAppPath
      udtAp.sAppIniPath = GetAppPath & $APPINIFILENAME
      udtAp.sAppDbPath  = GetAppPath & $APPDBFILENAME
      udtAp.sAppIdxPath = GetAppPath & $APPIDXFILENAME
      
      '= For Date and Time formats, SEE Above constants.
      udtAp.sbDateFmt   = %SB_DATELONG
      udtAp.sbTimeFmt   = %SB_TIMESHORT
      
      '= Initialize ReBar Variables.
      udtAp.rbRowCount  = 0
      udtAp.rbBandCount = 0
      
      '= Initialize StatusBar Variables.
      udtAp.sbTimePart = 1                 '= StatusBar Time Part = 1
      udtAp.sbDatePart = 2                 '= StatusBar Date Part = 2
      
      '= Check to see if the INI file exists if not create it!
      '= Fixed for GPF on application load if file was not found!!!
      IF FileExist(GetAppPath & $APPINIFILENAME) = %TRUE THEN
        AppLoadParams
      ELSE
        AppSaveParams
      END IF
      
      '============================================================================
      '= ADD And Create The Dialogs Controls.
      '============================================================================
      CreateRebar hDlg      '= Add A Main ReBar And ToolBar To The Dialog.
      
      '= Add A Main StatusBar To The Dialog.
      CONTROL ADD "msctls_statusbar32", hDlg, %ID_STATUSBAR, "MainStatusbar", _
                  0, 280, 420, 12, %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS
      
      DIM sbParts(0 TO 3)
      DIM sbText(0 TO 3)
      g_hSbFont = MakeFont("MS Sans Serif", 8, %FW_BOLD, %FALSE, %FALSE, %FALSE, %DEFAULT_CHARSET)
      CONTROL HANDLE hDlg, %ID_STATUSBAR TO hStatus
      SBarSize(hDlg)

';;      SETTIMER CBHNDL, %ID_SBTIMER, 1000, BYVAL %NULL '= Setup A Timer.

      SBarText 0, 0, " WinLift Simplified API - DDT Example"
      SendMessage (hStatus, %WM_SETFONT, g_hSbFont, 0)
      SBarTime udtAp.sbTimePart, 0, udtAp.sbTimeFmt '= Update The StatusBar Time.
      SBarDate udtAp.sbDatePart, 0, udtAp.sbDateFmt '= Update The StatusBar Date.

'     // WinLIFT section
      IF skInitEngine("Ipod.sks","") THEN
      'IF skInitEngine("Silver.sks","") THEN

'        // ProgressBar control added by Patrice
         Control Add "msctls_progress32", hDlg, %ID_PROGRESS, "", 10, 220, 400, 16, %WS_CHILD OR %WS_VISIBLE, %WS_EX_STATICEDGE
         Control Send hdlg, %ID_PROGRESS, %PBM_SETRANGE, 0, MakLng(0,100)
         Control Send hdlg, %ID_PROGRESS, %PBM_SETSTEP, 1, 0
         Control Send hdlg, %ID_PROGRESS, %PBM_SETPOS, 50, 0

         Control Add "msctls_trackbar32", hDlg, %ID_TRACKBAR, "", 11, 240, 398, 8, %WS_CHILD OR %WS_VISIBLE OR %TBS_NOTICKS
         Control Send hdlg, %ID_TRACKBAR, %TBM_SETRANGE, 0, MakLng(0,100)
         Control Send hdlg, %ID_TRACKBAR, %TBM_SETPAGESIZE, 0, 1
         Control Send hdlg, %ID_TRACKBAR, %TBM_SETLINESIZE, 0, 1
         Control Send hdlg, %ID_TRACKBAR, %TBM_SETTICFREQ, 0, 1
         Control Send hdlg, %ID_TRACKBAR, %TBM_SETPOS, 0, 50

         CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")
         CALL skSetAnchorCtrl(GetDlgItem(hDlg, %ID_PROGRESS), %ANCHOR_CENTER)
         CALL skSetAnchorCtrl(GetDlgItem(hDlg, %ID_TRACKBAR), %ANCHOR_CENTER)
      END IF

    CASE %WM_HSCROLL
         IF GetWindowLong(CBLPARAM, %GWL_ID) = %ID_TRACKBAR THEN
            LOCAL nPos AS LONG
            CONTROL SEND CBHNDL, %ID_TRACKBAR, %TBM_GETPOS, 0, 0 TO nPos
            CONTROL SEND CBHNDL, %ID_PROGRESS, %PBM_SETPOS, nPos, %TRUE
         END IF 

    CASE %WM_COMMAND
      SELECT CASE CBCTL
        CASE %IDM_NEW    : BEEP                  '= just to show it works..
        CASE %IDM_OPEN   : BEEP
        CASE %IDM_SAVE   : BEEP
        CASE %IDM_SAVEAS : BEEP
        CASE %IDM_EXIT   : DIALOG END CBHNDL     '= End the program
        CASE %IDM_UNDO
        CASE %IDM_CUT
        CASE %IDM_COPY
        CASE %IDM_PASTE
        CASE %IDM_SELALL                         '= Pass these on

        CASE %ID_EMAIL
          ExecuteURL "mailto:support@csdsoft.com"

      END SELECT

    CASE %WM_INITMENUPOPUP

    CASE %WM_MEASUREITEM, %WM_DRAWITEM               '= Pass these on and

    CASE %WM_SIZE                                    '= Resize to dialog
      MoveWindow hRebar, 0, 0, LOWRD(CBLPARAM), HIWRD(CBLPARAM), %TRUE
      '=======================================================================
      '= Forward The %WM_SIZE Event So That The Rebar, ToolBar AND StatusBar
      '= To Resizes Themselves.
      '=======================================================================
      CONTROL SEND CBHNDL, %ID_TOOLBAR,   CBMSG, 0, 0
      CONTROL SEND CBHNDL, %ID_STATUSBAR, CBMSG, 0, 0
      SBarSize(hDlg)                         '= Resize The StatusBar.

    CASE %WM_SKGETMENUICON
      IF CBWPARAM THEN
        SELECT CASE LONG CBWPARAM
          CASE %IDM_NEW   : hIcon = SetMenuBitmap(0)
          CASE %IDM_OPEN  : hIcon = SetMenuBitmap(1)
          CASE %IDM_SAVE  : hIcon = SetMenuBitmap(2)
          CASE %IDM_EXIT  : hIcon = SetMenuBitmap(31)

          CASE %IDM_UNDO  : hIcon = SetMenuBitmap(10)
          CASE %IDM_CUT   : hIcon = SetMenuBitmap(5)
          CASE %IDM_COPY  : hIcon = SetMenuBitmap(6)
          CASE %IDM_PASTE : hIcon = SetMenuBitmap(7)
        END SELECT
        '= Note the skEngine delete the returned hIcon handle once it has done with it
        FUNCTION = hIcon
      END IF
      EXIT FUNCTION

    CASE %WM_TIMER
      '= Update the StatusBar Date and Time Parts (Panel).
      SBarTime udtAp.sbTimePart, 0, udtAp.sbTimeFmt   '= Update The StatusBar Time.
      SBarDate udtAp.sbDatePart, 0, udtAp.sbDateFmt   '= Update The StatusBar Date.

    CASE %WM_NOTIFY
      '= Init pointer value
      pTOOLTIP = CBLPARAM

      IF @pTOOLTIP.hdr.code = %TTN_NEEDTEXT THEN
        '= Locate the tooltip text from the DATA
        FOR x = 1 TO DATACOUNT STEP 2
          IF VAL(READ$(x)) = @pTOOLTIP.hdr.idFrom THEN
            szTipText = READ$(x + 1)
            @pTOOLTIP.lpszText = VARPTR(szTipText)
            FUNCTION = 1
            EXIT FOR
          END IF
        NEXT x
      END IF

    CASE %WM_DESTROY
      '========================================================================
      '= Clean-up and release all of our used Resources...
      '= First we save all the application parameters.
      '========================================================================
      AppTerminate hDlg                   '= Save Application Data.

      IF hRebar    THEN DestroyWindow hRebar
      IF hToolBar  THEN DestroyWindow hToolbar

      '= Clean-Up And Delete Our ImageList Handles
      IF g_hImlHot THEN ImageList_Destroy g_hImlHot
      IF g_hImlDis THEN ImageList_Destroy g_hImlDis
      IF g_hImlSel THEN ImageList_Destroy g_hImlSel

      IF g_hRbBack THEN DeleteObject(g_hRbBack)

      IF g_hSbFont THEN DeleteObject(g_hSbFont)

';;      KillTimer CBHNDL, %ID_SBTIMER       '= Kill Our Timer.

  END SELECT

  '============================================================================
  '= Data Comprises The ID Of Toolbar Buttons, Followed By The Tooltips
  '= Description Text.
  '============================================================================
  DATA 101,   "New File"
  DATA 102,   "Open File"
  DATA 103,   "Save File"
  DATA 104,   "Print File"
  DATA 105,   "Print Preview"
  DATA 106,   "Cut"
  DATA 107,   "Copy"
  DATA 108,   "Paste"
  DATA 114,   "Email Us"

END FUNCTION

'==============================================================================
'= APPLICATIONS FUNCTIONS AND SUB-ROUTINES.
'==============================================================================

'==============================================================================
'= FUNCTION : GetMenuTxt(BYVAL ItemId AS LONG) AS STRING
'= DESC     :
'==============================================================================
'= PARAMS   :
'=          :
'==============================================================================
'= RETURNS  : Return menu item string
'==============================================================================
'= NOTES    :
'==============================================================================
FUNCTION GetMenuTxt(BYVAL ItemId AS LONG) AS STRING

  SELECT CASE ItemId
     CASE %IDM_FILE    : FUNCTION = "&File"
     CASE %IDM_NEW     : FUNCTION = "&New"     & CHR$(9) & "Ctrl + N"
     CASE %IDM_OPEN    : FUNCTION = "&Open..." & CHR$(9) & "Ctrl + O"
     CASE %IDM_SAVE    : FUNCTION = "&Save"    & CHR$(9) & "Ctrl + S"
     CASE %IDM_SAVEAS  : FUNCTION = "&Save as..."
     CASE %IDM_EXIT    : FUNCTION = "E&xit"    & CHR$(9) & "Alt + F4"

     CASE %IDM_EDIT    : FUNCTION = "&Edit"
     CASE %IDM_UNDO    : FUNCTION = "&Undo"    & CHR$(9) & "Ctrl + Z"
     CASE %IDM_CUT     : FUNCTION = "Cu&t"     & CHR$(9) & "Ctrl + X"
     CASE %IDM_COPY    : FUNCTION = "&Copy"    & CHR$(9) & "Ctrl + C"
     CASE %IDM_PASTE   : FUNCTION = "&Paste"   & CHR$(9) & "Ctrl + V"
     CASE %IDM_SELALL  : FUNCTION = "Select &All" & CHR$(9) & "Ctrl + A"
  END SELECT

END FUNCTION

'==============================================================================
'= SUB     : MenuEditSet(BYVAL wParam AS LONG)
'= DESC    : Enable or disable edit menu items
'==============================================================================
'= PARAMS  :
'=         :
'==============================================================================
'= RETURNS : NONE.
'==============================================================================
'= NOTES   : NONE.
'==============================================================================
SUB MenuEditSet(BYVAL wParam AS LONG)
  LOCAL lRes AS LONG, selStart AS LONG, selEnd AS LONG

  IF SendMessage(hEdit, %EM_CANUNDO, 0, 0) THEN          '<- UNDO
     CALL EnableMenuItem (wParam, %IDM_UNDO, %MF_ENABLED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_UNDO, %MF_GRAYED)
  END IF

  lRes = SendMessage(hEdit, %EM_GETSEL, VARPTR(selStart), VARPTR(selEnd))
  IF selStart = selEnd THEN                               '<- CUT & COPY
     CALL EnableMenuItem (wParam, %IDM_CUT, %MF_GRAYED)
     CALL EnableMenuItem (wParam, %IDM_COPY, %MF_GRAYED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_CUT, %MF_ENABLED)
     CALL EnableMenuItem (wParam, %IDM_COPY, %MF_ENABLED)
  END IF

  IF IsClipboardFormatAvailable(%CF_TEXT) THEN            '<- PASTE
     CALL EnableMenuItem (wParam, %IDM_PASTE, %MF_ENABLED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_PASTE, %MF_GRAYED)
  END IF

  IF SendMessage(hEdit, %WM_GETTEXTLENGTH, 0, 0) THEN      '<- SELECT ALL
     CALL EnableMenuItem (wParam, %IDM_SELALL, %MF_ENABLED)
  ELSE
     CALL EnableMenuItem (wParam, %IDM_SELALL, %MF_GRAYED)
  END IF

END SUB

FUNCTION SetMenuBitmap (BYVAL bNum AS LONG) AS LONG

  LOCAL hBmp1 AS LONG, hBmp2 AS LONG, hDC AS LONG, memDC1 AS LONG, memDC2 AS LONG

' Load the bitmap to use
' ~~~~~~~~~~~~~~~~~~~~~~
  hBmp1 = LoadImage(GetModuleHandle(BYVAL 0&), BYVAL 1, %IMAGE_BITMAP, 0, 0, %LR_LOADMAP3DCOLORS)

' Grab Screen's DC and create two compatible memory DC's
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  hdc    = GetDc(0)
  memDC1 = CreateCompatibleDC (hdc)
  memDC2 = CreateCompatibleDC (hdc)

' Create 16x16 pixel bitmap
' ~~~~~~~~~~~~~~~~~~~~~~~~~
  hBmp2 = CreateCompatibleBitmap(hdc, 16, 16)

' Release the dc - don't need it anymore.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  ReleaseDC 0, hdc

' Select the bitmaps into the memory DC's
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  SelectObject memDC1, hBmp1
  SelectObject memDC2, hBmp2

' Copy selected part of bitmap1 to bitmap2
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  BitBlt memDC2, 0, 0, 16, 16, memDC1, bNum * 16, 0, %SRCCOPY

' Cleanup
' ~~~~~~~
  DeleteDC memDC1
  DeleteDC memDC2
  DeleteObject hBmp1    '(hBmp2 is deleted in DrawMenuItem)

  FUNCTION = hBmp2      'return handle to stretched bitmap

END FUNCTION

FUNCTION AppTerminate(BYVAL hDlg AS DWORD) AS LONG

  SaveRebarBandPos      '= Gets the Rebar info for saving.

  '============================================================================
  '= Save All The Application Parameters To The Applications INI File.
  '============================================================================
  udtAp.sAppPath    = GetAppPath
  udtAp.sAppIniPath = GetAppPath & $APPINIFILENAME
  udtAp.sAppDbPath  = GetAppPath & $APPDBFILENAME
  udtAp.sAppDbPath  = GetAppPath & $APPDBFILENAME
  udtAp.sAppIdxPath = GetAppPath & $APPIDXFILENAME

  '= Save Date and Time formats to INI file.
  '= SEE: STATUSBAR.INC for these Constants.
  udtAp.sbTimeFmt   = %SB_TIMESHORT
  udtAp.sbDateFmt   = %SB_DATELONG
  udtAp.sbTimePart  = 1
  udtAp.sbDatePart  = 2

  '= Save Application Parameters.
  AppSaveParams

END FUNCTION



