'
' Template for DDT main dialog
'--------------------------------------------------------------------
#COMPILE EXE "Buttons.exe"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

%WM_USER                                        = &H400
%WM_DRAWITEM                                    = &H2B
%WM_INITDIALOG                                  = &H110
%WM_COMMAND                                     = &H111
%WS_OVERLAPPED                                  = &H0
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_VSCROLL                                     = &H00200000
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%WS_OVERLAPPEDWINDOW                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%HWND_TOP                                       = 0
%HWND_BOTTOM                                    = 1

%BS_LEFT            = &H100&
%BS_RIGHT           = &H200&
%BS_CENTER          = &H300&
%BS_TOP             = &H400&
%BS_BOTTOM          = &H800&
%BS_VCENTER         = &HC00&


%IDC_BTN_LEFT     = 101
%IDC_BTN_PLAY     = 102
%IDC_BTN_RIGHT    = 103
%IDC_BTN_CHECK    = 104
%IDC_BTN_DELETE   = 105
%IDC_BTN_RECYCLE  = 106
%IDC_BTN_PRINT    = 107
%IDC_BTN_TEXT     = 108
%IDC_BTN_SAVE     = 109
%IDC_BTN_32BIT    = 110
%IDC_BTN_64BIT    = 111
%IDC_BTN_00       = 112
%IDC_BTN_01       = 113
%IDC_BTN_02       = 114
%IDC_BTN_03       = 115
%IDC_BTN_04       = 116
%IDC_BTN_05       = 117
%IDC_BTN_06       = 118
%IDC_BTN_07       = 119
%IDC_BTN_08       = 120
%IDC_BTN_09       = 121
%IDC_CLOCK        = 122
%IDC_FRAME        = 123
%IDC_LIPS         = 124

'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc() AS LONG

#INCLUDE "WINLIFT.INC"

'
' Main entrance
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD, hCtrl AS LONG, sResource AS STRING
 
  DIALOG NEW PIXELS, 0, "Buttons",,, 480, 360, %WS_OVERLAPPEDWINDOW, 0 TO hDlg


  IF skInitEngine("Sony.sks", "") THEN
     CALL skSkinWindow(hDlg, "Dock|Undock|Minimize|Maximize|Restore|Close")

     sResource = EXE.Path$ + "Resource\"

     hCtrl = skButtonImage(hDlg, sResource + "BTN_Left.png", 216-57, 300+12, %IDC_BTN_LEFT, 5)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)

     hCtrl = skButtonImage(hDlg, sResource + "BTN_Play.png", 216, 300, %IDC_BTN_PLAY, 5)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)

     hCtrl = skButtonImage(hDlg, sResource + "BTN_Right.png", 216+49, 300+12, %IDC_BTN_RIGHT, 5)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)


     hCtrl = skPushButtonImage(hDlg, sResource + "Check_32.png", "%BS_LEFT", 20, 20, 140, 50, %IDC_BTN_CHECK, %BS_LEFT OR %BS_VCENTER)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ)

     hCtrl = skPushButtonImage(hDlg, sResource + "Delete_32.png", "%BS_CENTER", 20 + 140 + 8, 20, 140, 50, %IDC_BTN_DELETE, %BS_CENTER OR %BS_VCENTER)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ)

     hCtrl = skPushButtonImage(hDlg, sResource + "Recycle_32.png", "%BS_RIGHT", 20 + (140 + 8) * 2, 20, 140, 50, %IDC_BTN_RECYCLE, %BS_RIGHT OR %BS_VCENTER)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ)


     hCtrl = skPushButtonImage(hDlg, sResource + "Print_32.png", "%BS_TOP", 20, 20 + 70, 140, 50, %IDC_BTN_PRINT, %BS_TOP)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)

     hCtrl = skPushButtonImage(hDlg, "", "Pristina font", 20 + 140 + 8, 20 + 70, 140, 50, %IDC_BTN_TEXT, %BS_CENTER OR %BS_VCENTER)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     CALL skSetLabelFont(hCtrl, "Pristina", 28, skARGB(255, 255,255,0), %FontStyleRegular)

     hCtrl = skPushButtonImage(hDlg, sResource + "Save_32.png", "%BS_BOTTOM", 20 + (140 + 8) * 2, 20 + 70, 140, 50, %IDC_BTN_SAVE, %BS_BOTTOM)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)

     hCtrl = skPushButtonImage(hDlg, sResource + "00_32.png", "", 40 + (40 * 0), 20 + 140, 38, 38, %IDC_BTN_00, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "01_32.png", "", 40 + (40 * 1), 20 + 140, 38, 38, %IDC_BTN_01, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "02_32.png", "", 40 + (40 * 2), 20 + 140, 38, 38, %IDC_BTN_02, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "03_32.png", "", 40 + (40 * 3), 20 + 140, 38, 38, %IDC_BTN_03, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "04_32.png", "", 40 + (40 * 4), 20 + 140, 38, 38, %IDC_BTN_04, 0)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "05_32.png", "", 40 + (40 * 5), 20 + 140, 38, 38, %IDC_BTN_05, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "06_32.png", "", 40 + (40 * 6), 20 + 140, 38, 38, %IDC_BTN_06, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "07_32.png", "", 40 + (40 * 7), 20 + 140, 38, 38, %IDC_BTN_07, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "08_32.png", "", 40 + (40 * 8), 20 + 140, 38, 38, %IDC_BTN_08, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)
     hCtrl = skPushButtonImage(hDlg, sResource + "09_32.png", "", 40 + (40 * 9), 20 + 140, 38, 38, %IDC_BTN_09, 0)  
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER)


'    // 4.73 WinLIFT clock 
'    hCtrl = skClockCtrl(hDlg, sResource + "Clock_06_92.png", 14, 258, 0, 0, %IDC_CLOCK, &HFFCBCBCB, &H7F9F9F9F, 0)
'    hCtrl = skClockCtrl(hDlg, sResource + "Clock_02_92.png", 14, 258, 0, 0, %IDC_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
'    hCtrl = skClockCtrl(hDlg, sResource + "Clock_03_92.png", 14, 258, 0, 0, %IDC_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
'    hCtrl = skClockCtrl(hDlg, sResource + "Clock_01_92.png", 14, 258, 0, 0, %IDC_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
     hCtrl = skClockCtrl(hDlg, sResource + "Clock_08_92.png", 14, 258, 0, 0, %IDC_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM)

'    hCtrl = skButtonImage(hDlg, sResource + "32bit_80.png", 20, 264, %IDC_BTN_32BIT, 5)
'    CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM)

     hCtrl = skButtonImage(hDlg, sResource + "64bit_80.png", 380, 264, %IDC_BTN_64BIT, 5)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM_RIGHT)

'    // Version 4.85
     hCtrl = skStaticImage(hDlg, sResource + "Aero.png", 10, 10, 460, 208, %IDC_FRAME)
     CALL skSetZorder(hCtrl, %HWND_BOTTOM)
     CALL skSetAnchorCtrl(hCtrl, %ANCHOR_HEIGHT_WIDTH)
'    // Version 4.85
     hCtrl = skStaticImage(hDlg, sResource + "makeuplips.png", -20, -70, 200, 134, %IDC_LIPS)
     CALL skSetZorder(hCtrl, %HWND_TOP)

  END IF

  DIALOG SHOW MODAL hDlg CALL DlgProc

END FUNCTION
 
'
' Main callback
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgProc() AS LONG

  SELECT CASE CBMSG

     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN 'end prog
                 DIALOG END CBHNDL
              END IF
 
        END SELECT

  END SELECT
END FUNCTION
